"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Datastore = require("nedb");
var lodash_1 = require("lodash");
var path = require('path');
var StoreResult = /** @class */ (function () {
    function StoreResult() {
    }
    StoreResult.of = function (data, upsert) {
        return { data: lodash_1.cloneDeep(data), upsert: upsert };
    };
    return StoreResult;
}());
exports.StoreResult = StoreResult;
var CertificateDatabase = /** @class */ (function () {
    function CertificateDatabase(databaseBaseFolderPath) {
        this.db = null;
        var filename = path.join(databaseBaseFolderPath, 'certificates.db');
        var pathOrOptions = {
            filename: filename,
            autoload: true,
        };
        console.log('Creating certificate store: ' + JSON.stringify(pathOrOptions));
        var datastore = new Datastore(pathOrOptions);
        datastore.ensureIndex({ fieldName: 'ski', unique: true });
        this.db = datastore;
    }
    CertificateDatabase.prototype.save = function (cert) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.db.loadDatabase(function (err) {
                if (lodash_1.isNil(err)) {
                    _this.db.update({ ski: cert.ski }, cert, { upsert: true, returnUpdatedDocs: true }, function (err, count, docs, upsert) {
                        if (lodash_1.isNil(err)) {
                            resolve(StoreResult.of(cert, !!upsert));
                        }
                        else {
                            reject(err);
                        }
                    });
                }
            });
        });
    };
    return CertificateDatabase;
}());
exports.CertificateDatabase = CertificateDatabase;
//# sourceMappingURL=CertificateDatabase.js.map