"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var uuid_1 = require("uuid");
var default_1 = require("../../environments/default");
var electron_main_1 = require("../../electron.main");
var fetch = require('node-fetch');
exports.isTestingEnv = !!electron_main_1.LAUNCH_ARGS.cl;
var Uploader = /** @class */ (function () {
    function Uploader(options) {
        this.options = options;
        this.logger = console;
        this.enabled = true;
        this.customizationsMetrics = {
            "standard": "cd3",
            "visura": "cd4",
            "camerfirma": "cd5",
            "certeurope": "cd6",
            "international": "cd7",
            "zucchetti": "cd8",
            "eni": "cd9",
        };
        this.customizationsMetricsCL = {
            "standard": "cd1",
            "visura": "cd2",
            "camerfirma": "cd3",
            "certeurope": "cd4",
            "international": "cd5",
            "zucchetti": "cd6",
            "eni": "cd7",
        };
        if (!!electron_main_1.LAUNCH_ARGS.tdd) {
            this.enabled = false;
            console.log("Analitics disabled by tdd flag");
        }
        else {
            this.initGA4Clients();
        }
    }
    Uploader.prototype.getClientID = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (this.clientID) {
                    return [2 /*return*/, Promise.resolve(this.clientID)];
                }
                else {
                    return [2 /*return*/, this.options.get('gaid', uuid_1.v4()).then(function (res) {
                            return res.data.value;
                        })];
                }
                return [2 /*return*/];
            });
        });
    };
    Uploader.prototype.initGA4Clients = function () {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var standardGoogleGA4, currentCustomization, customMetric;
            return __generator(this, function (_c) {
                standardGoogleGA4 = exports.isTestingEnv ? default_1.environment.google_ga4_cl : default_1.environment.google_ga4;
                currentCustomization = (electron_main_1.PROFILE === null || electron_main_1.PROFILE === void 0 ? void 0 : electron_main_1.PROFILE.customization) || 'standard';
                console.log('🚀 ~ Analytics ~ currentCustomization', currentCustomization);
                customMetric = exports.isTestingEnv ? (_a = this.customizationsMetricsCL) === null || _a === void 0 ? void 0 : _a[currentCustomization] : (_b = this.customizationsMetrics) === null || _b === void 0 ? void 0 : _b[currentCustomization];
                this.clientsGA4 = [__assign(__assign({}, standardGoogleGA4), { custom_dimensions: {} })];
                if (electron_main_1.PROFILE === null || electron_main_1.PROFILE === void 0 ? void 0 : electron_main_1.PROFILE.google_ga4) {
                    this.logger.info("Found customization profile.google_ga4 = " + (electron_main_1.PROFILE === null || electron_main_1.PROFILE === void 0 ? void 0 : electron_main_1.PROFILE.google_ga4));
                    this.clientsGA4.push(__assign(__assign({}, electron_main_1.PROFILE.google_ga4), { custom_dimensions: {} }));
                }
                this.clientsGA4.map(function (client) {
                    client.custom_dimensions['mobileDeviceBranding'] = currentCustomization;
                    client.custom_dimensions['customization'] = currentCustomization;
                    if (customMetric) {
                        client.custom_dimensions[customMetric] = "1";
                    }
                });
                return [2 /*return*/];
            });
        });
    };
    Uploader.prototype.sendScreenView = function (message) {
        if (!this.enabled) {
            return Promise.resolve(message);
        }
        this.logger.info("Sending ScreenView " + JSON.stringify(message));
        // Send GA4 Event
        var appName = message.an, appVersion = message.av, installationType = message.fl, userAgent = message.ua, architectureString = message.aiid;
        this.clientsGA4.map(function (client) {
            client.custom_dimensions = __assign(__assign({}, client.custom_dimensions), { appName: appName,
                appVersion: appVersion,
                installationType: installationType,
                userAgent: userAgent,
                architectureString: architectureString });
        });
        return this.sendGA4Event({
            event_action: 'page_view',
            event_category: 'screenview',
            event_label: 'StartApp',
            page_title: 'MainWindow',
            page_location: 'https://gosign.it',
        });
    };
    Uploader.prototype.sendEvent = function (message) {
        if (!this.enabled) {
            return Promise.resolve(message);
        }
        this.logger.info("Sending Event " + JSON.stringify(message));
        // Send GA4 Event to all GA4 clients
        var event_category = message.ec, event_action = message.ea, event_label = message.el, value = message.ev;
        return this.sendGA4Event({
            event_category: event_category,
            event_action: event_action,
            event_label: event_label,
            value: value
        });
    };
    Uploader.prototype.setLogged = function (logged) {
        if (!this.enabled) {
            return Promise.resolve(logged);
        }
        this.logger.info("Setting Logged metric to " + logged);
        var loggedValue = logged ? '1' : '0';
        this.clientsGA4.map(function (client) {
            client.custom_dimensions['logged'] = loggedValue;
            client.custom_dimensions['cd1'] = loggedValue;
        });
        return Promise.resolve(logged);
    };
    Uploader.prototype.setIsPRO = function (isPRO) {
        if (!this.enabled) {
            return Promise.resolve(isPRO);
        }
        this.logger.info("Setting PRO metric to " + isPRO);
        var isPROValue = isPRO ? '1' : '0';
        this.clientsGA4.map(function (client) {
            client.custom_dimensions['isPRO'] = isPROValue;
            client.custom_dimensions['cd2'] = isPROValue;
        });
        return Promise.resolve(isPRO);
    };
    Uploader.prototype.setCustomization = function (customization) {
        var _a, _b;
        if (!this.enabled) {
            return Promise.resolve(customization);
        }
        console.log("🚀 ~ setCustomization ~ isTestingEnv", exports.isTestingEnv);
        var customMetric = exports.isTestingEnv ? (_a = this.customizationsMetricsCL) === null || _a === void 0 ? void 0 : _a[customization] : (_b = this.customizationsMetrics) === null || _b === void 0 ? void 0 : _b[customization];
        if (!customMetric)
            Promise.reject("no metric for customization " + customization + " found");
        this.logger.info("set Customization metric to " + customization + " " + customMetric + "  ");
        this.clientsGA4.map(function (client) {
            client.custom_dimensions['customization'] = customization;
            client.custom_dimensions[customMetric] = '1';
        });
        return Promise.resolve(customization);
    };
    Uploader.prototype.getCustomization = function (customization) {
        var _a, _b;
        console.log("🚀 ~ setCustomization ~ isTestingEnv", exports.isTestingEnv);
        var customMetric = exports.isTestingEnv ? (_a = this.customizationsMetricsCL) === null || _a === void 0 ? void 0 : _a[customization] : (_b = this.customizationsMetrics) === null || _b === void 0 ? void 0 : _b[customization];
        if (!customMetric)
            Promise.reject("no metric for customization " + customization + " found");
        this.logger.info("set Customization metric to " + customization + " " + customMetric + "  ");
        return customMetric;
        // return this.client.then((client) => {
        //   return new Promise<string>((resolve, reject) => {
        //     client.set(customMetric, '1');
        //     resolve(customization);
        //   });
        // });
    };
    /**
     * Send GA4 Event for each client
     * @param message
     */
    Uploader.prototype.sendGA4Event = function (message) {
        return __awaiter(this, void 0, void 0, function () {
            var client_id, user_id;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.enabled) {
                            return [2 /*return*/, Promise.resolve(message)];
                        }
                        client_id = '1505783504.1674490861' //await this.getClientID()
                        ;
                        return [4 /*yield*/, this.getClientID()];
                    case 1:
                        user_id = _a.sent();
                        this.clientsGA4.map(function (client) {
                            var api_secret = client.api_secret, measurement_id = client.measurement_id;
                            var eventPayload = {
                                name: message.event_action,
                                params: __assign(__assign({ 
                                    //Accettazione dei termini e condizioni completi
                                    gcs: "G111", ad_storage: "granted", analytics_storage: "granted", ads_data_redaction: true, 
                                    //wait_for_update: 500,
                                    //https://stackoverflow.com/a/71811327/1479680
                                    engagement_time_msec: 1 }, message), (client === null || client === void 0 ? void 0 : client.custom_dimensions) || {}),
                            };
                            var body = JSON.stringify({
                                client_id: client_id,
                                user_id: user_id,
                                events: [eventPayload]
                            });
                            var url = "https://www.google-analytics.com/mp/collect?measurement_id=" + measurement_id + "&api_secret=" + api_secret;
                            console.log("🚀 ~ Uploader ~ sendGA4Event ~ body", url, body);
                            return fetch(url, {
                                method: "POST",
                                body: body
                            }).catch(function (error) {
                                console.log("🚀 ~ Uploader ~ sendGA4Event ~ error", error);
                            });
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    return Uploader;
}());
exports.Uploader = Uploader;
//# sourceMappingURL=Uploader.js.map