"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
//@ts-nocheck
var dikeClients_1 = require("./dikeClients");
var logger_1 = require("./logger");
var logger = logger_1.provideLogger('CoreAuthenticationService');
var CoreAuthenticationService = /** @class */ (function () {
    function CoreAuthenticationService(analyticsEventHandler, protocol_name) {
        this.analyticsEventHandler = analyticsEventHandler;
        this.protocol_name = protocol_name;
    }
    ;
    CoreAuthenticationService.prototype.parseCommandline = function (commandLine) {
        var _this = this;
        console.log('Protocol name parseCommandline', this.protocol_name);
        return commandLine
            .filter(function (value) { return value.match(_this.protocol_name); })
            .map(function (value) {
            var _a, _b;
            var url = new URL(value);
            var operation = !((_a = url === null || url === void 0 ? void 0 : url.pathname) === null || _a === void 0 ? void 0 : _a.includes("OAUTH_AUTHORIZE_EID")) ? (!((_b = url === null || url === void 0 ? void 0 : url.pathname) === null || _b === void 0 ? void 0 : _b.includes("OAUTH_AUTHORIZE")) ? "webSign" : "authorize") : "eid";
            return {
                code: url.searchParams.get('code'),
                state: url.searchParams.get('state'),
                url: value,
                operation: operation
            };
        })
            .filter(function (value) { return value != null; })
            .shift();
    };
    CoreAuthenticationService.prototype.authorize = function (value) {
        var _this = this;
        logger.debug("Authorizing user %s", JSON.stringify(value));
        var instance = dikeClients_1.DikeClients.getInstance();
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, instance.getOauthAuthorize(value.state, value.code).then(function () {
                            _this.analyticsEventHandler.setLogged(true);
                            _this.analyticsEventHandler.sendGoSignWeb('Login');
                            instance.getOauthIdentity(false)
                                .then(function (identity) {
                                logger.debug("Authorized user %s", identity);
                                console.log("Authorized user %s", identity);
                                resolve({
                                    operation: "authorize",
                                    value: identity
                                });
                            })
                                .catch(function (reason) {
                                logger.debug("ERROR Authorized reason %s", reason);
                                console.log("ERROR Authorized reason %s", reason);
                                resolve({
                                    operation: "authorize",
                                    error: (reason === null || reason === void 0 ? void 0 : reason.message) || reason
                                });
                            });
                        }).catch(function (reason) {
                            logger.debug("ERROR Authorized reason %s", reason);
                            console.log("authorize ERROR", reason);
                            resolve({
                                operation: "authorize",
                                error: (reason === null || reason === void 0 ? void 0 : reason.message) || reason
                            });
                        })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
    };
    CoreAuthenticationService.prototype.eidAuthorize = function (value) {
        var _this = this;
        logger.debug("Authorizing EID user %s", JSON.stringify(value));
        var instance = dikeClients_1.DikeClients.getInstance();
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var signer, reason_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, instance.getEIDGAuthorize(value.state, value.code)];
                    case 1:
                        signer = _a.sent();
                        resolve({
                            operation: "eid",
                            value: signer
                        });
                        return [3 /*break*/, 3];
                    case 2:
                        reason_1 = _a.sent();
                        logger.debug("ERROR EID Authorized reason %s", reason_1);
                        console.log("eidAuthorize ERROR", reason_1);
                        resolve({
                            operation: "eid",
                            error: (reason_1 === null || reason_1 === void 0 ? void 0 : reason_1.message) || reason_1
                        });
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        }); });
    };
    return CoreAuthenticationService;
}());
exports.CoreAuthenticationService = CoreAuthenticationService;
//# sourceMappingURL=CoreAuthenticationService.js.map