"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var request_1 = require("../shared/request");
var model_1 = require("../model");
var DikeErrors_1 = require("../shared/DikeErrors");
var dikeClients_1 = require("../../electron/dikeClients");
var timestampRequestService_1 = require("../../electron/timestampRequestService");
var AssociateFilesChannel = /** @class */ (function () {
    function AssociateFilesChannel() {
    }
    AssociateFilesChannel.prototype.handleRequest = function (body) {
        console.log('Associate files operation');
        return dikeClients_1.DikeClients.getInstance().associateTimestamp(body.file.inputPath, body.timestampPath, body.file.outputPath, request_1.mapFromCoreTimestampFormat(body.associateFormat));
    };
    return AssociateFilesChannel;
}());
exports.AssociateFilesChannel = AssociateFilesChannel;
var AssociateValidateRequestChannel = /** @class */ (function () {
    function AssociateValidateRequestChannel() {
    }
    AssociateValidateRequestChannel.prototype.handleRequest = function (body) {
        console.log('Associate request validation');
        if (body.status === 'NEW') {
            return timestampRequestService_1.default.validateAssociateRequest(body);
        }
        else {
            Promise.reject(model_1.DikeError.of(DikeErrors_1.DikeErrors.INVALID_STATUS, "Invalid request status " + body.status));
        }
    };
    return AssociateValidateRequestChannel;
}());
exports.AssociateValidateRequestChannel = AssociateValidateRequestChannel;
//# sourceMappingURL=AssociateHandlers.js.map