"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
//@ts-nocheck
var eidg_1 = require("@ice/dike-core-js/lib/types/eidg");
var electron_1 = require("electron");
var dikeClients_1 = require("../dikeClients");
var logger_1 = require("../logger");
//const EIDG_CALLBACK_URL = 'diker://dike/OAUTH_AUTHORIZE_EID';
var EIDG_CALLBACK_URL = "://dike/OAUTH_AUTHORIZE_EID";
var logger = logger_1.provideLogger('CNSAuthenticationHandlers');
var StartCNSAuthenticationChannel = /** @class */ (function () {
    function StartCNSAuthenticationChannel(protocol_name) {
        this.protocol_name = protocol_name;
    }
    StartCNSAuthenticationChannel.prototype.handleRequest = function (body) {
        console.log('Protocol name StartCNSAuthenticationChannel', this.protocol_name);
        logger.info("Starting login flow");
        var instance = dikeClients_1.DikeClients.getInstance();
        var configurationType = eidg_1.EIDGConfiguration.CNSSignature;
        return instance.getEIDGUrl(this.protocol_name + EIDG_CALLBACK_URL, configurationType).then(function (EIDGUrl) {
            logger.info("Opening browser to '" + EIDGUrl.url + "'");
            var url1 = new URL(EIDGUrl.url);
            return electron_1.shell.openExternal(url1.toString()).then(function () { return ({}); });
        });
    };
    return StartCNSAuthenticationChannel;
}());
exports.StartCNSAuthenticationChannel = StartCNSAuthenticationChannel;
var CNSEmissionOneShot = /** @class */ (function () {
    function CNSEmissionOneShot() {
    }
    CNSEmissionOneShot.prototype.handleRequest = function (body) {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.getEIDGOneshotEmission(body.authorize, body.clausole, body.numFirme, body.email, body.coupon, body.identifier);
    };
    return CNSEmissionOneShot;
}());
exports.CNSEmissionOneShot = CNSEmissionOneShot;
//# sourceMappingURL=CNSAuthenticationHandlers.js.map