"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var dikeClients_1 = require("../dikeClients");
var rxjs_1 = require("rxjs");
var electron_1 = require("electron");
var Utils_1 = require("../Utils");
var path = require("path");
var registry_1 = require("../registry");
var logger_1 = require("../../electron/logger");
var ElectronLog = require("electron-log");
var i18n = require('i18n');
var os = require('os');
var logger = logger_1.provideLogger('ConfigurationHandlers');
var GetConfigurationChannel = /** @class */ (function () {
    function GetConfigurationChannel() {
        this._ev = new rxjs_1.Subject();
        this.events = this._ev.asObservable();
    }
    GetConfigurationChannel.prototype.handleRequest = function (body) {
        var _this = this;
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.getConfiguration().then(function (value) { return __awaiter(_this, void 0, void 0, function () {
            var appName, appFolder, updateExe, exeName, coreLogLevel, newLogLevel;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(electron_1.app.getLoginItemSettings().openAtLogin != !value.user.DisableAutostart)) return [3 /*break*/, 3];
                        appName = path.parse(process.execPath).name;
                        console.log("🚀 ~ GetConfigurationChannel ~ returninstance.getConfiguration ~ appName:", appName);
                        if (!(['win32'].includes(os.platform()) && Utils_1.isSquirrel())) return [3 /*break*/, 2];
                        appFolder = path.dirname(process.execPath);
                        updateExe = path.resolve(appFolder, '..', 'Update.exe');
                        exeName = path.basename(process.execPath);
                        return [4 /*yield*/, registry_1.cleanStartupRegistry()];
                    case 1:
                        _a.sent();
                        electron_1.app.setLoginItemSettings({
                            openAtLogin: !value.user.DisableAutostart,
                            openAsHidden: true,
                            path: updateExe,
                            name: "it.infocert.desktop.gosign",
                            args: [
                                '--processStart', "\"" + exeName + "\"",
                                '--process-start-args', "\"--start-tray\""
                            ]
                        });
                        return [3 /*break*/, 3];
                    case 2:
                        electron_1.app.setLoginItemSettings({
                            openAtLogin: !value.user.DisableAutostart,
                            openAsHidden: true,
                            args: ['--start-tray'],
                        });
                        _a.label = 3;
                    case 3:
                        // updates electron locale
                        i18n.setLocale(value.gui.language);
                        this._ev.next(value);
                        coreLogLevel = value.user.loglevel.toLowerCase();
                        newLogLevel = coreLogLevel === "trace" ? "debug" : coreLogLevel;
                        console.log("🚀 ~ GetConfigurationChannel ~ returninstance.getConfiguration ~ logLevel:", { coreLogLevel: coreLogLevel, newLogLevel: newLogLevel });
                        //ELECTRON LOG
                        // logger.error('Questo è un log di errore', { log: "pippo", age: 9999 }); // Verrà scritto nel file
                        // logger.warn('Questo è un log di warning'); // Verrà scritto nel file
                        // logger.info('Questo è un log di informazione'); // NON verrà scritto nel file
                        // logger.debug('Questo è un log di debug', { log: "pippo", age: 9999 }); // NON verrà scritto nel file
                        ElectronLog.transports.file.level = newLogLevel;
                        logger_1.setLoggerLevel(newLogLevel);
                        // logger.error('Questo è un log di errore'); // Verrà scritto nel file
                        // logger.warn('Questo è un log di warning'); // Verrà scritto nel file
                        // logger.info('Questo è un log di informazione'); // NON verrà scritto nel file
                        // logger.debug('Questo è un log di debug', { log: "pippo", age: 9999 }); // NON verrà scritto nel file
                        return [2 /*return*/, value];
                }
            });
        }); });
    };
    return GetConfigurationChannel;
}());
exports.GetConfigurationChannel = GetConfigurationChannel;
var GetScreenZoom = /** @class */ (function () {
    function GetScreenZoom(getZoomValueFunction) {
        this.getZoomValueFunction = getZoomValueFunction;
    }
    GetScreenZoom.prototype.handleRequest = function (body) {
        return __awaiter(this, void 0, void 0, function () {
            var zoom, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.getZoomValueFunction()];
                    case 1:
                        zoom = _a.sent();
                        return [2 /*return*/, zoom];
                    case 2:
                        error_1 = _a.sent();
                        console.error('Error getting zoom value:', error_1);
                        throw error_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return GetScreenZoom;
}());
exports.GetScreenZoom = GetScreenZoom;
// export class GetZoom implements IpcHandler<void,number>{
//   private getZoomValueFunction:()=>Promise<number>;
//   constructor(getZoomValueFunction:() =>  Promise<number>) {
//     this.getZoomValueFunction = getZoomValueFunction;
//   }
//    handleRequest(body:void): Promise<number> {
//     try {
//       const zoom =  this.getZoomValueFunction(); // Chiama la funzione passata nel costruttore
//       return zoom;
//     } catch (error) {
//       console.error('Error getting zoom value:', error);
//       throw error;
//     }
//   }
// }
var SaveDebugLogs = /** @class */ (function () {
    function SaveDebugLogs() {
    }
    SaveDebugLogs.prototype.handleRequest = function (body) {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.saveVerboseLogs(body);
    };
    return SaveDebugLogs;
}());
exports.SaveDebugLogs = SaveDebugLogs;
var SetConfigurationChannel = /** @class */ (function () {
    function SetConfigurationChannel() {
    }
    SetConfigurationChannel.prototype.handleRequest = function (body) {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.setConfiguration(body.prop, body.json);
    };
    return SetConfigurationChannel;
}());
exports.SetConfigurationChannel = SetConfigurationChannel;
var CheckConnection = /** @class */ (function () {
    function CheckConnection() {
    }
    CheckConnection.prototype.handleRequest = function () {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.checkConnection();
    };
    return CheckConnection;
}());
exports.CheckConnection = CheckConnection;
//# sourceMappingURL=ConfigurationHandlers.js.map