"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var dikeClients_1 = require("../dikeClients");
var flows_1 = require("@ice/dike-core-js/lib/types/flows");
var genericFsm_1 = require("../FSM/genericFsm");
var FSM_1 = require("../FSM");
var model_1 = require("../model");
var DECIPHER_FLOW_TYPE = flows_1.FlowType.DGS_FLOW_DECRYPT;
// WIP: akokot - add flow return type FsmMessage<DecipherDone> when ready
var DecipherFsmInitChannel = /** @class */ (function () {
    function DecipherFsmInitChannel() {
    }
    DecipherFsmInitChannel.prototype.handleRequest = function (body) {
        console.log('Decipher initialization');
        var genericFsm = genericFsm_1.GenericFsm.of(DECIPHER_FLOW_TYPE, dikeClients_1.DikeClients.getInstance());
        genericFsm_1.FsmRegistry.getInstance().set(DECIPHER_FLOW_TYPE, genericFsm);
        return genericFsm.init().then(function () { return genericFsm.nextState()
            .then(function (v) { return FSM_1.fromState(v); }); });
    };
    return DecipherFsmInitChannel;
}());
exports.DecipherFsmInitChannel = DecipherFsmInitChannel;
var DecipherFsmPerformChannel = /** @class */ (function () {
    function DecipherFsmPerformChannel() {
    }
    DecipherFsmPerformChannel.prototype.handleRequest = function (body) {
        console.log("Decipher performing operation '%s'", body);
        var payload = model_1.mapToDecryptParamsInserted(body); // WIP: akokot - add payload mapping
        var genericFsm = genericFsm_1.FsmRegistry.getInstance().get(DECIPHER_FLOW_TYPE);
        return genericFsm.send(flows_1.FlowEvent.DGS_EVT_DECRYPT_PARAMS_INSERTED, payload)
            .then(function (v) { return FSM_1.fromState(v); });
    };
    return DecipherFsmPerformChannel;
}());
exports.DecipherFsmPerformChannel = DecipherFsmPerformChannel;
//# sourceMappingURL=DecipherHandlers.js.map