"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var electron_main_1 = require("../../electron.main");
var dikeClients_1 = require("../dikeClients");
var GetTslFsmChannel = /** @class */ (function () {
    function GetTslFsmChannel() {
    }
    GetTslFsmChannel.prototype.handleRequest = function (body) {
        return dikeClients_1.DikeClients.getInstance()
            .getTsl()
            .then(function (res) {
            // @ts-ignore
            var result = { countries: res.countries };
            return result;
        })
            .catch(function () {
            var result = { countries: [] };
            return result;
        });
    };
    return GetTslFsmChannel;
}());
exports.GetTslFsmChannel = GetTslFsmChannel;
var AddTSLFsmChannel = /** @class */ (function () {
    function AddTSLFsmChannel() {
    }
    AddTSLFsmChannel.prototype.handleRequest = function (countryCode) {
        return dikeClients_1.DikeClients.getInstance().addTsl(countryCode);
    };
    return AddTSLFsmChannel;
}());
exports.AddTSLFsmChannel = AddTSLFsmChannel;
var RemoveTSLFsmChannel = /** @class */ (function () {
    function RemoveTSLFsmChannel() {
    }
    RemoveTSLFsmChannel.prototype.handleRequest = function (countryCode) {
        return dikeClients_1.DikeClients.getInstance().removeTsl(countryCode);
    };
    return RemoveTSLFsmChannel;
}());
exports.RemoveTSLFsmChannel = RemoveTSLFsmChannel;
var CheckUpdatesTSLFsmChannel = /** @class */ (function () {
    function CheckUpdatesTSLFsmChannel() {
    }
    CheckUpdatesTSLFsmChannel.prototype.handleRequest = function (countryCode) {
        if (electron_main_1.LAUNCH_ARGS['skiptslupdate']) {
            console.info("Skipped by LAUNCH_ARGS skiptslupdate");
            return Promise.resolve({ countries: [] });
        }
        return dikeClients_1.DikeClients.getInstance().checkUpdatesTsl();
    };
    return CheckUpdatesTSLFsmChannel;
}());
exports.CheckUpdatesTSLFsmChannel = CheckUpdatesTSLFsmChannel;
var UpdateTSLFsmChannel = /** @class */ (function () {
    function UpdateTSLFsmChannel() {
    }
    UpdateTSLFsmChannel.prototype.handleRequest = function (tsl_to_update) {
        return dikeClients_1.DikeClients.getInstance().updateTsl(tsl_to_update);
    };
    return UpdateTSLFsmChannel;
}());
exports.UpdateTSLFsmChannel = UpdateTSLFsmChannel;
var GetATLChannel = /** @class */ (function () {
    function GetATLChannel() {
    }
    GetATLChannel.prototype.handleRequest = function (body) {
        console.log("Retrieving Atl chains", body);
        return dikeClients_1.DikeClients.getInstance().getATL(body.forced);
    };
    return GetATLChannel;
}());
exports.GetATLChannel = GetATLChannel;
var ReloadTslChannel = /** @class */ (function () {
    function ReloadTslChannel() {
    }
    ReloadTslChannel.prototype.handleRequest = function (body) {
        console.log("Reload TSL");
        return dikeClients_1.DikeClients.getInstance().reloadTsl();
    };
    return ReloadTslChannel;
}());
exports.ReloadTslChannel = ReloadTslChannel;
//# sourceMappingURL=European_TLS_Handles.js.map