"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var electron_1 = require("electron");
var dikeClients_1 = require("../dikeClients");
var model_1 = require("../model");
var DikeErrors_1 = require("../shared/DikeErrors");
var path = require("path");
var lodash_1 = require("lodash");
var os_1 = require("os");
var fs = require("fs-extra");
var mime = require('mime');
var FileSaveSelectionChannel = /** @class */ (function () {
    function FileSaveSelectionChannel(resolver) {
        this.resolver = resolver;
    }
    FileSaveSelectionChannel.prototype.handleRequest = function (body) {
        var _this = this;
        return electron_1.dialog.showSaveDialog(this.resolver(), this.getFileSaveOptions(body)).then(function (value) {
            return _this.parseResponse(value);
        });
    };
    FileSaveSelectionChannel.prototype.parseResponse = function (value) {
        if (!!value.canceled) {
            return {
                status: 'DISMISS',
            };
        }
        else {
            return {
                status: 'OK',
                path: value.filePath,
            };
        }
    };
    FileSaveSelectionChannel.prototype.getFileSaveOptions = function (coreFileSelectionRequests) {
        var filseSaveOptions = __assign(__assign({}, coreFileSelectionRequests), { filters: coreFileSelectionRequests.filters, properties: coreFileSelectionRequests.properties });
        return filseSaveOptions;
    };
    return FileSaveSelectionChannel;
}());
exports.FileSaveSelectionChannel = FileSaveSelectionChannel;
var FileSelectionChannel = /** @class */ (function () {
    function FileSelectionChannel(resolver) {
        this.resolver = resolver;
    }
    FileSelectionChannel.prototype.handleRequest = function (body) {
        var _this = this;
        return electron_1.dialog.showOpenDialog(this.resolver(), this.getFileOpenOptions(body)).then(function (value) {
            return _this.parseResponse(value);
        });
    };
    FileSelectionChannel.prototype.parseResponse = function (value) {
        if (!!value.canceled) {
            return {
                status: 'DISMISS',
            };
        }
        else {
            return {
                status: 'OK',
                paths: value.filePaths,
            };
        }
    };
    FileSelectionChannel.prototype.getFileOpenOptions = function (coreFileSelectionRequests) {
        return __assign({}, coreFileSelectionRequests);
    };
    return FileSelectionChannel;
}());
exports.FileSelectionChannel = FileSelectionChannel;
var FileLoadChannel = /** @class */ (function () {
    function FileLoadChannel() {
    }
    FileLoadChannel.prototype.handleRequest = function (body) {
        return new Promise(function (resolve, reject) {
            fs.readFile(body, { encoding: 'base64' }, function (error, data) {
                if (error) {
                    reject(error);
                }
                else {
                    var fileMime = mime.getType(body);
                    var response = {
                        content: "data:" + fileMime + ";base64," + data.toString(),
                        status: 'OK',
                    };
                    resolve(response);
                }
            });
        });
    };
    return FileLoadChannel;
}());
exports.FileLoadChannel = FileLoadChannel;
var FileOsOpenChannel = /** @class */ (function () {
    function FileOsOpenChannel() {
    }
    FileOsOpenChannel.prototype.handleRequest = function (body) {
        return new Promise(function (resolve, reject) {
            var ok = electron_1.shell.openPath(body);
            if (ok) {
                resolve({});
            }
            else {
                var error = {
                    code: DikeErrors_1.DikeErrors.OS_FILE_OPENING_ERROR,
                    message: 'Error while opening file with default OS application',
                };
                reject(error);
            }
        });
    };
    return FileOsOpenChannel;
}());
exports.FileOsOpenChannel = FileOsOpenChannel;
var OpenFileFolder = /** @class */ (function () {
    function OpenFileFolder() {
    }
    OpenFileFolder.prototype.handleRequest = function (body) {
        return new Promise(function (resolve, reject) {
            electron_1.shell.showItemInFolder(body);
            resolve({});
        });
    };
    return OpenFileFolder;
}());
exports.OpenFileFolder = OpenFileFolder;
var GetUserHome = /** @class */ (function () {
    function GetUserHome() {
    }
    GetUserHome.prototype.handleRequest = function (body) {
        return new Promise(function (resolve, reject) {
            var homedir = require('os').homedir();
            resolve(homedir);
        });
    };
    return GetUserHome;
}());
exports.GetUserHome = GetUserHome;
var LoadAssetChannel = /** @class */ (function () {
    function LoadAssetChannel() {
    }
    LoadAssetChannel.prototype.handleRequest = function (body) {
        return new Promise(function (resolve, reject) {
            var instance = dikeClients_1.DikeClients.getInstance();
            var assetsFolder = instance.assetsFolder;
            fs.readFile(assetsFolder + '/' + body.filename, { encoding: 'base64' }, function (error, data) {
                if (error) {
                    reject(error);
                }
                else {
                    var fileMime = mime.getType(body);
                    var response = {
                        base64: "data:" + fileMime + ";base64," + data.toString(),
                    };
                    resolve(response);
                }
            });
        });
    };
    return LoadAssetChannel;
}());
exports.LoadAssetChannel = LoadAssetChannel;
var SaveAssetChannel = /** @class */ (function () {
    function SaveAssetChannel() {
    }
    SaveAssetChannel.prototype.handleRequest = function (body, encoding) {
        var _this = this;
        if (encoding === void 0) { encoding = "base64"; }
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var filename, base64, _a, isTemp, instance, savePath, session_tmpdir;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        filename = body.filename, base64 = body.base64, _a = body.isTemp, isTemp = _a === void 0 ? false : _a;
                        instance = dikeClients_1.DikeClients.getInstance();
                        savePath = "";
                        if (!isTemp) return [3 /*break*/, 2];
                        return [4 /*yield*/, instance.getSessionParams()];
                    case 1:
                        session_tmpdir = (_b.sent()).session_tmpdir;
                        savePath = session_tmpdir + '/' + filename;
                        return [3 /*break*/, 3];
                    case 2:
                        savePath = instance.assetsFolder + '/' + filename;
                        _b.label = 3;
                    case 3:
                        fs.writeFile(savePath, base64, { encoding: encoding }, function (error) {
                            if (error) {
                                reject(error);
                            }
                            else {
                                var response = { path: savePath };
                                resolve(response);
                            }
                        });
                        return [2 /*return*/];
                }
            });
        }); });
    };
    return SaveAssetChannel;
}());
exports.SaveAssetChannel = SaveAssetChannel;
var RemoveAssetChannel = /** @class */ (function () {
    function RemoveAssetChannel() {
    }
    RemoveAssetChannel.prototype.handleRequest = function (body) {
        return new Promise(function (resolve, reject) {
            var instance = dikeClients_1.DikeClients.getInstance();
            var assetsFolder = instance.assetsFolder;
            fs.unlink(assetsFolder + '/' + body.filename, function (error) {
                if (error) {
                    reject(error);
                }
                else {
                    resolve({});
                }
            });
        });
    };
    return RemoveAssetChannel;
}());
exports.RemoveAssetChannel = RemoveAssetChannel;
var RemoveFileChannel = /** @class */ (function () {
    function RemoveFileChannel() {
    }
    RemoveFileChannel.prototype.handleRequest = function (body) {
        return new Promise(function (resolve, reject) {
            var filename = body.filename;
            var pathToDelete = filename;
            if (!path.isAbsolute(filename)) {
                var instance = dikeClients_1.DikeClients.getInstance();
                var homePath = instance.homePath;
                pathToDelete = homePath + '/' + filename;
            }
            fs.unlink(pathToDelete, function (error) {
                if (error) {
                    resolve(error);
                }
                else {
                    resolve({});
                }
            });
        });
    };
    return RemoveFileChannel;
}());
exports.RemoveFileChannel = RemoveFileChannel;
var ClearFolderChannel = /** @class */ (function () {
    function ClearFolderChannel() {
    }
    ClearFolderChannel.prototype.handleRequest = function (body) {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var directory, folderToClear, instance, session_tmpdir;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        directory = body.directory;
                        folderToClear = directory;
                        if (!!path.isAbsolute(directory)) return [3 /*break*/, 2];
                        instance = dikeClients_1.DikeClients.getInstance();
                        return [4 /*yield*/, instance.getSessionParams()];
                    case 1:
                        session_tmpdir = (_a.sent()).session_tmpdir;
                        folderToClear = session_tmpdir + '/' + directory;
                        _a.label = 2;
                    case 2:
                        console.log("🚀 ~ ClearFolderChannel ~ returnnewPromise ~ folderToClear:", folderToClear);
                        fs.readdir(folderToClear, function (err, files) {
                            if (err) {
                                console.error(err);
                                reject(err); // reject with the error object
                                return;
                            }
                            var promises = files.map(function (file) {
                                var filePath = path.join(folderToClear, file);
                                return new Promise(function (resolve, reject) {
                                    fs.unlink(filePath, function (err) {
                                        if (err) {
                                            reject(err); // reject with the error object
                                        }
                                        else {
                                            resolve(); // resolve when file is deleted successfully
                                        }
                                    });
                                });
                            });
                            Promise.all(promises).then(function () {
                                resolve(true); // resolve with true when all files are deleted
                            }).catch(function (err) {
                                reject(err); // reject with the error object
                            });
                        });
                        return [2 /*return*/];
                }
            });
        }); });
    };
    return ClearFolderChannel;
}());
exports.ClearFolderChannel = ClearFolderChannel;
var PathParseChannel = /** @class */ (function () {
    function PathParseChannel() {
    }
    PathParseChannel.prototype.handleRequest = function (body) {
        return new Promise(function (resolve, reject) {
            try {
                var parsed = path.parse(body.path);
                resolve({
                    root: parsed.root,
                    dir: parsed.dir,
                    base: parsed.base,
                    ext: parsed.ext,
                    name: parsed.name,
                });
            }
            catch (e) {
                console.error(e);
                reject({ error: e });
            }
        });
    };
    return PathParseChannel;
}());
exports.PathParseChannel = PathParseChannel;
var CreateDirectoryChannelImpl = /** @class */ (function () {
    function CreateDirectoryChannelImpl(logger) {
        this.logger = logger;
    }
    CreateDirectoryChannelImpl.prototype.handleRequest = function (body) {
        this.logger.info("Creating path '%s'", body.path);
        var normalized = path.normalize(body.path);
        return new Promise(function (resolve) {
            fs.mkdir(body.path, { recursive: true }, function (err) {
                if (err) {
                    return resolve({ success: false, path: '' });
                }
                return resolve({ success: true, path: normalized });
            });
        });
    };
    return CreateDirectoryChannelImpl;
}());
exports.CreateDirectoryChannelImpl = CreateDirectoryChannelImpl;
var PathJoinChannel = /** @class */ (function () {
    function PathJoinChannel() {
    }
    PathJoinChannel.prototype.handleRequest = function (body) {
        return new Promise(function (resolve, reject) {
            try {
                resolve(path.join.apply(path, body.paths));
            }
            catch (e) {
                console.error(e);
                reject({ error: e });
            }
        });
    };
    return PathJoinChannel;
}());
exports.PathJoinChannel = PathJoinChannel;
var PathIsDirectoryChannel = /** @class */ (function () {
    function PathIsDirectoryChannel() {
    }
    PathIsDirectoryChannel.prototype.handleRequest = function (body) {
        var _this = this;
        return this.isDirectory(body.path).then(function (isDirectory) { return isDirectory && _this.isWriteable(body.path); });
    };
    PathIsDirectoryChannel.prototype.isDirectory = function (dirPath) {
        return new Promise(function (resolve, reject) {
            try {
                resolve(fs.lstatSync(dirPath).isDirectory());
            }
            catch (e) {
                if (e.code == 'ENOENT') {
                    resolve(true);
                }
                else {
                    console.error(e);
                    reject({ error: e });
                }
            }
        });
    };
    PathIsDirectoryChannel.prototype.isWriteable = function (dirPath) {
        return new Promise(function (resolve, reject) {
            fs.access(dirPath, fs.constants.F_OK | fs.constants.W_OK, function (err) {
                return resolve(err && err.code != 'ENOENT' ? false : true);
            });
        });
    };
    return PathIsDirectoryChannel;
}());
exports.PathIsDirectoryChannel = PathIsDirectoryChannel;
var DirectoryExistChannel = /** @class */ (function () {
    function DirectoryExistChannel() {
    }
    DirectoryExistChannel.prototype.handleRequest = function (body) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, exist, empty;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.directoryExistAndIsNotEmpty(body.path)];
                    case 1:
                        _a = _b.sent(), exist = _a.exist, empty = _a.empty;
                        return [2 /*return*/, { exist: exist, empty: empty }];
                }
            });
        });
    };
    DirectoryExistChannel.prototype.directoryExistAndIsNotEmpty = function (dirPath) {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var exist, empty, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        exist = false;
                        empty = false;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 5, , 6]);
                        return [4 /*yield*/, this.directoryExist(dirPath)];
                    case 2:
                        exist = _a.sent();
                        if (!exist) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.directoryIsEmpty(dirPath)];
                    case 3:
                        empty = _a.sent();
                        _a.label = 4;
                    case 4:
                        resolve({ exist: exist, empty: empty });
                        return [3 /*break*/, 6];
                    case 5:
                        e_1 = _a.sent();
                        resolve({ exist: exist, empty: empty });
                        return [3 /*break*/, 6];
                    case 6: return [2 /*return*/];
                }
            });
        }); });
    };
    DirectoryExistChannel.prototype.directoryExist = function (dirPath) {
        return new Promise(function (resolve, reject) {
            try {
                if (fs.existsSync(dirPath)) {
                    resolve(true);
                }
                else {
                    resolve(false);
                }
            }
            catch (e) {
                resolve(false);
            }
        });
    };
    DirectoryExistChannel.prototype.directoryIsEmpty = function (dirPath) {
        return fs.promises.readdir(dirPath).then(function (files) {
            return files.length === 0;
        });
    };
    return DirectoryExistChannel;
}());
exports.DirectoryExistChannel = DirectoryExistChannel;
var FileExistChannel = /** @class */ (function () {
    function FileExistChannel() {
    }
    FileExistChannel.prototype.handleRequest = function (body) {
        return __awaiter(this, void 0, void 0, function () {
            var exist;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.fileExist(body.filename)];
                    case 1:
                        exist = _a.sent();
                        return [2 /*return*/, exist];
                }
            });
        });
    };
    FileExistChannel.prototype.fileExist = function (filename) {
        return new Promise(function (resolve, reject) {
            var pathToCheck = filename;
            if (!path.isAbsolute(filename)) {
                var instance = dikeClients_1.DikeClients.getInstance();
                var homePath = instance.homePath;
                pathToCheck = homePath + '/' + filename;
            }
            try {
                if (fs.existsSync(pathToCheck)) {
                    resolve(true);
                }
                else {
                    resolve(false);
                }
            }
            catch (e) {
                resolve(false);
            }
        });
    };
    return FileExistChannel;
}());
exports.FileExistChannel = FileExistChannel;
var FileLoadBufferChannel = /** @class */ (function () {
    function FileLoadBufferChannel() {
    }
    FileLoadBufferChannel.prototype.handleRequest = function (body) {
        return new Promise(function (resolve, reject) {
            fs.readFile(body, function (error, data) {
                if (error) {
                    reject(error);
                }
                else {
                    var response = {
                        content: data,
                        status: 'OK',
                    };
                    resolve(response);
                }
            });
        });
    };
    return FileLoadBufferChannel;
}());
exports.FileLoadBufferChannel = FileLoadBufferChannel;
var FileLoadUtf8Channel = /** @class */ (function () {
    function FileLoadUtf8Channel() {
    }
    FileLoadUtf8Channel.prototype.handleRequest = function (filename) {
        var pathToFile = filename;
        if (!path.isAbsolute(filename)) {
            var instance = dikeClients_1.DikeClients.getInstance();
            var homePath = instance.homePath;
            pathToFile = homePath + '/' + filename;
        }
        return new Promise(function (resolve, reject) {
            fs.readFile(pathToFile, 'utf8', function (error, data) {
                if (error) {
                    reject(error);
                }
                else {
                    var response = {
                        content: data,
                        status: 'OK',
                    };
                    resolve(response);
                }
            });
        });
    };
    return FileLoadUtf8Channel;
}());
exports.FileLoadUtf8Channel = FileLoadUtf8Channel;
var OpenBkDriversDir = /** @class */ (function () {
    function OpenBkDriversDir(driversPath, logger) {
        this.driversPath = driversPath;
        this.logger = logger;
    }
    OpenBkDriversDir.prototype.directory = function () {
        return lodash_1.cond([
            [function (e) { return lodash_1.isEqual(e, 'win32'); }, function () { return 'windows'; }],
            [function (e) { return lodash_1.isEqual(e, 'darwin'); }, function () { return 'macos'; }],
            [function (e) { return lodash_1.isEqual(e, 'linux'); }, function () { return 'linux'; }],
        ])(os_1.platform());
    };
    OpenBkDriversDir.prototype.handleRequest = function (body) {
        var _this = this;
        var driverDirectory = lodash_1.cond([
            [function (e) { return lodash_1.isEqual(e, 'BIT'); }, function () { return 'bit_driver/' + _this.directory(); }],
            [function (e) { return lodash_1.isEqual(e, 'ST'); }, function () { return 'st_driver/' + _this.directory(); }],
            [
                lodash_1.stubTrue,
                function () {
                    throw new Error('Invalid value!');
                },
            ],
        ])(body.driverType);
        var driverPath = path.join(this.driversPath, driverDirectory);
        this.logger.info('Opening path for drivers "%s"', driverPath);
        if (electron_1.shell.openPath(driverPath)) {
            return Promise.resolve({});
        }
        else {
            return Promise.reject(model_1.DikeError.of(DikeErrors_1.DikeErrors.BK_DRIVERS_OPENING_ERROR, 'Cannot open item'));
        }
    };
    return OpenBkDriversDir;
}());
exports.OpenBkDriversDir = OpenBkDriversDir;
var OpenBkDrivers = /** @class */ (function () {
    function OpenBkDrivers(driversPath, logger) {
        this.driversPath = driversPath;
        this.logger = logger;
    }
    OpenBkDrivers.prototype.extension = function () {
        return lodash_1.cond([
            [function (e) { return lodash_1.isEqual(e, 'win32'); }, function () { return 'exe'; }],
            [function (e) { return lodash_1.isEqual(e, 'darwin'); }, function () { return 'dmg'; }],
            [function (e) { return lodash_1.isEqual(e, 'linux'); }, function () { return 'deb'; }],
        ])(os_1.platform());
    };
    OpenBkDrivers.prototype.handleRequest = function (body) {
        var _this = this;
        var driverExecutable = lodash_1.cond([
            [function (e) { return lodash_1.isEqual(e, 'BIT'); }, function () { return 'bit_driver.' + _this.extension(); }],
            [function (e) { return lodash_1.isEqual(e, 'ST'); }, function () { return 'st_driver.' + _this.extension(); }],
            [
                lodash_1.stubTrue,
                function () {
                    throw new Error('Invalid value!');
                },
            ],
        ])(body.driverType);
        var driverPaths = path.join(this.driversPath, driverExecutable);
        this.logger.info('Opening path for drivers "%s"', driverPaths);
        if (electron_1.shell.openPath(driverPaths)) {
            return Promise.resolve({});
        }
        else {
            return Promise.reject(model_1.DikeError.of(DikeErrors_1.DikeErrors.BK_DRIVERS_OPENING_ERROR, 'Cannot open item'));
        }
    };
    return OpenBkDrivers;
}());
exports.OpenBkDrivers = OpenBkDrivers;
var SaveFileToTempChannel = /** @class */ (function () {
    function SaveFileToTempChannel(logger) {
        this.logger = logger;
    }
    SaveFileToTempChannel.prototype.handleRequest = function (body) {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var instance, session_tmpdir, base64, savePath, encoding, subfolder, destinationPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        instance = dikeClients_1.DikeClients.getInstance();
                        if (!!this.session_tmpdir) return [3 /*break*/, 2];
                        this.logger.info('this.session_tmpdir NOT found "%s"', this.session_tmpdir);
                        return [4 /*yield*/, instance.getSessionParams()];
                    case 1:
                        session_tmpdir = (_a.sent()).session_tmpdir;
                        this.session_tmpdir = session_tmpdir;
                        _a.label = 2;
                    case 2:
                        base64 = body.base64, savePath = body.savePath, encoding = body.encoding, subfolder = body.subfolder;
                        this.logger.info('this.session_tmpdir found "%s"', this.session_tmpdir);
                        destinationPath = this.session_tmpdir + '/' + savePath;
                        if (subfolder) {
                            destinationPath = this.session_tmpdir + '/' + subfolder + '/' + savePath;
                        }
                        // Create the directory if it doesn't exist
                        fs.ensureDir(path.dirname(destinationPath))
                            .then(function () {
                            fs.writeFile(destinationPath, base64, { encoding: encoding }, function (error) {
                                if (error) {
                                    reject(error);
                                }
                                else {
                                    var response = { path: destinationPath };
                                    resolve(response);
                                }
                            });
                        })
                            .catch(function (error) {
                            reject(error);
                        });
                        return [2 /*return*/];
                }
            });
        }); });
    };
    return SaveFileToTempChannel;
}());
exports.SaveFileToTempChannel = SaveFileToTempChannel;
var SaveFileUtf8 = /** @class */ (function () {
    function SaveFileUtf8() {
    }
    SaveFileUtf8.prototype.handleRequest = function (body) {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var data, savePath, pathToFile, instance, homePath;
            return __generator(this, function (_a) {
                data = body.data, savePath = body.savePath;
                pathToFile = savePath;
                if (!path.isAbsolute(savePath)) {
                    instance = dikeClients_1.DikeClients.getInstance();
                    homePath = instance.homePath;
                    pathToFile = homePath + '/' + savePath;
                }
                fs.writeFile(pathToFile, data, 'utf8', function (error) {
                    if (error) {
                        reject(error);
                    }
                    else {
                        var response = { path: savePath };
                        resolve(response);
                    }
                });
                return [2 /*return*/];
            });
        }); });
    };
    return SaveFileUtf8;
}());
exports.SaveFileUtf8 = SaveFileUtf8;
var CopyFile = /** @class */ (function () {
    function CopyFile() {
        this.homePath = "";
        var instance = dikeClients_1.DikeClients.getInstance();
        this.homePath = instance.homePath;
    }
    CopyFile.prototype.handleRequest = function (_a) {
        var _this = this;
        var source = _a.source, destination = _a.destination;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var newDestination;
            return __generator(this, function (_a) {
                newDestination = destination;
                if (!path.isAbsolute(destination)) {
                    newDestination = this.homePath + '/' + destination;
                }
                console.log("🚀 ~ CopyFile:", source, newDestination);
                fs.copyFile(source, newDestination, function (err) {
                    if (err) {
                        // Create the destination directory if it doesn't exist
                        fs.mkdirp(path.dirname(newDestination), function (mkdirErr) {
                            if (mkdirErr) {
                                reject(mkdirErr);
                            }
                            else {
                                fs.copyFile(source, newDestination, function (copyErr) {
                                    if (copyErr) {
                                        reject(copyErr);
                                    }
                                    else {
                                        console.log(source + ' copied to ' + newDestination);
                                        resolve(newDestination);
                                    }
                                });
                            }
                        });
                    }
                    else {
                        console.log(source + ' copied to ' + newDestination);
                        resolve(newDestination);
                    }
                });
                return [2 /*return*/];
            });
        }); });
    };
    return CopyFile;
}());
exports.CopyFile = CopyFile;
var GetUserFolders = /** @class */ (function () {
    function GetUserFolders() {
    }
    GetUserFolders.prototype.handleRequest = function () {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var instance, homePath, tempPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        instance = dikeClients_1.DikeClients.getInstance();
                        homePath = instance.homePath;
                        return [4 /*yield*/, instance.getSessionParams()];
                    case 1:
                        tempPath = (_a.sent()).session_tmpdir;
                        resolve({ homePath: homePath, tempPath: tempPath });
                        return [2 /*return*/];
                }
            });
        }); });
    };
    return GetUserFolders;
}());
exports.GetUserFolders = GetUserFolders;
var PdfImageCombine = /** @class */ (function () {
    function PdfImageCombine() {
    }
    PdfImageCombine.prototype.handleRequest = function (_a) {
        var _this = this;
        var signature_file = _a.signature_file, output_file = _a.output_file, _b = _a.params, params = _b === void 0 ? {} : _b;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var instance, final_outuput_file, homePath, signComposed, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        instance = dikeClients_1.DikeClients.getInstance();
                        final_outuput_file = output_file;
                        if (!path.isAbsolute(output_file)) {
                            homePath = instance.homePath;
                            final_outuput_file = homePath + '/' + output_file;
                        }
                        console.log("🚀 ~ pdfImageCombine ", { signature_file: signature_file, final_outuput_file: final_outuput_file, params: params });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, instance.pdfImageCombine(signature_file, final_outuput_file, params)];
                    case 2:
                        signComposed = _a.sent();
                        resolve(signComposed);
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        reject(err_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
    };
    return PdfImageCombine;
}());
exports.PdfImageCombine = PdfImageCombine;
//# sourceMappingURL=FileOperationsHandlers.js.map