"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var dikeClients_1 = require("../dikeClients");
var electron_1 = require("electron");
var path = require("path");
var GetVersionChannel = /** @class */ (function () {
    function GetVersionChannel() {
    }
    GetVersionChannel.prototype.handleRequest = function (body) {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.getVersion().then(function (version) {
            return {
                app_version: electron_1.app.getVersion(),
                version: version,
            };
        });
    };
    return GetVersionChannel;
}());
exports.GetVersionChannel = GetVersionChannel;
var GetAppPath = /** @class */ (function () {
    function GetAppPath() {
    }
    GetAppPath.prototype.handleRequest = function (body) {
        return Promise.resolve(path.join(electron_1.app.getAppPath(), '/dist/assets/'));
    };
    return GetAppPath;
}());
exports.GetAppPath = GetAppPath;
var GetSessionParams = /** @class */ (function () {
    function GetSessionParams() {
    }
    GetSessionParams.prototype.handleRequest = function (body) {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.getSessionParams().then(function (sessionParams) {
            return sessionParams;
        });
    };
    return GetSessionParams;
}());
exports.GetSessionParams = GetSessionParams;
var MakeZip = /** @class */ (function () {
    function MakeZip() {
    }
    MakeZip.prototype.handleRequest = function (body) {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.makeZip(body).then(function (zipPath) {
            return zipPath;
        });
    };
    return MakeZip;
}());
exports.MakeZip = MakeZip;
var CheckPdf = /** @class */ (function () {
    function CheckPdf() {
    }
    CheckPdf.prototype.handleRequest = function (inputFiles) {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.checkPDF(inputFiles).then(function (fileResults) {
            return fileResults;
        });
    };
    return CheckPdf;
}());
exports.CheckPdf = CheckPdf;
var GetAppDir = /** @class */ (function () {
    function GetAppDir() {
    }
    GetAppDir.prototype.handleRequest = function (name) {
        if (name === void 0) { name = "desktop"; }
        var desktopDir = electron_1.app.getPath(name);
        return Promise.resolve(desktopDir);
    };
    return GetAppDir;
}());
exports.GetAppDir = GetAppDir;
//# sourceMappingURL=GetVersionChannel.js.map