"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var dikeClients_1 = require("../dikeClients");
var gosign_1 = require("@ice/dike-core-js/lib/types/gosign");
var electron_1 = require("electron");
var logger_1 = require("../logger");
var logger = logger_1.provideLogger('GoSignWebHandlers');
var GoSignWebSendAndSignChannel = /** @class */ (function () {
    function GoSignWebSendAndSignChannel(analyticsEventHandler) {
        this.analyticsEventHandler = analyticsEventHandler;
    }
    GoSignWebSendAndSignChannel.prototype.handleRequest = function (body) {
        var _this = this;
        logger.info("Send and sign %s", JSON.stringify(body));
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance
            .getGosignUrl(gosign_1.GOSIGN_URL.DGS_GOSIGN_SEND_AND_SIGN, { files: body.files })
            .then(function (value) {
            _this.analyticsEventHandler.sendGoSignWeb("SendAndSign");
            return electron_1.shell.openExternal(value.url);
        })
            .then(function () { return ({}); });
    };
    return GoSignWebSendAndSignChannel;
}());
exports.GoSignWebSendAndSignChannel = GoSignWebSendAndSignChannel;
var GoSignWebCreateEnvelopeChannel = /** @class */ (function () {
    function GoSignWebCreateEnvelopeChannel(analyticsEventHandler) {
        this.analyticsEventHandler = analyticsEventHandler;
    }
    GoSignWebCreateEnvelopeChannel.prototype.handleRequest = function (body) {
        var _this = this;
        logger.info("Create envelope");
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance
            .getGosignUrl(gosign_1.GOSIGN_URL.DGS_GOSIGN_CREATE_ENVELOPE, { files: [] })
            .then(function (value) {
            _this.analyticsEventHandler.sendGoSignWeb("CreateEnvelope");
            return electron_1.shell.openExternal(value.url);
        })
            .then(function () { return ({}); });
    };
    return GoSignWebCreateEnvelopeChannel;
}());
exports.GoSignWebCreateEnvelopeChannel = GoSignWebCreateEnvelopeChannel;
var GoSignWebSignBookChannel = /** @class */ (function () {
    function GoSignWebSignBookChannel(analyticsEventHandler) {
        this.analyticsEventHandler = analyticsEventHandler;
    }
    GoSignWebSignBookChannel.prototype.handleRequest = function (body) {
        var _this = this;
        logger.info("WebSignBook");
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance
            .getGosignUrl(gosign_1.GOSIGN_URL.DGS_GOSIGN_SIGN_BOOK, { files: [] })
            .then(function (value) {
            _this.analyticsEventHandler.sendGoSignWeb("SignBook");
            return electron_1.shell.openExternal(value.url);
        })
            .then(function () { return ({}); });
    };
    return GoSignWebSignBookChannel;
}());
exports.GoSignWebSignBookChannel = GoSignWebSignBookChannel;
//# sourceMappingURL=GoSignWebHandlers.js.map