"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var dikeClients_1 = require("../dikeClients");
var LicensingFsmChannelDeactivate = /** @class */ (function () {
    function LicensingFsmChannelDeactivate() {
    }
    LicensingFsmChannelDeactivate.prototype.handleRequest = function (body) {
        return dikeClients_1.DikeClients.getInstance()
            .unbindLicense(body.code)
            .then(function (value) {
            return value;
        });
    };
    return LicensingFsmChannelDeactivate;
}());
exports.LicensingFsmChannelDeactivate = LicensingFsmChannelDeactivate;
var LicensingFsmChannelRemove = /** @class */ (function () {
    function LicensingFsmChannelRemove() {
    }
    LicensingFsmChannelRemove.prototype.handleRequest = function () {
        return dikeClients_1.DikeClients.getInstance()
            .removeLicense()
            .then(function (value) {
            return value;
        });
    };
    return LicensingFsmChannelRemove;
}());
exports.LicensingFsmChannelRemove = LicensingFsmChannelRemove;
var LicensingFsmChannelValidate = /** @class */ (function () {
    function LicensingFsmChannelValidate() {
    }
    LicensingFsmChannelValidate.prototype.handleRequest = function (body) {
        return dikeClients_1.DikeClients.getInstance()
            .bindLicense(body.code)
            .then(function (value) {
            return value;
        });
    };
    return LicensingFsmChannelValidate;
}());
exports.LicensingFsmChannelValidate = LicensingFsmChannelValidate;
function createEmptyLicense() {
    return {
        expirationDate: '',
        licenseCode: '',
        commandLine: false,
        multiSignLimit: -1,
        multiSignEnabled: false,
    };
}
var LicensingFsmChannelRetrieveStatus = /** @class */ (function () {
    function LicensingFsmChannelRetrieveStatus(analyticsEventHandler) {
        this.analyticsEventHandler = analyticsEventHandler;
    }
    LicensingFsmChannelRetrieveStatus.prototype.handleRequest = function (body) {
        var _this = this;
        return dikeClients_1.DikeClients.getInstance()
            .getLicense()
            .then(function (value) {
            _this.analyticsEventHandler.setIsPRO(true);
            //console.log('LICENSE HANDLER VALUE', value)
            return value;
        })
            .catch(function (err) {
            var result = createEmptyLicense();
            _this.analyticsEventHandler.setIsPRO(false);
            //console.log('LICENSE HANDLE ERROR', err)
            return result;
        });
    };
    return LicensingFsmChannelRetrieveStatus;
}());
exports.LicensingFsmChannelRetrieveStatus = LicensingFsmChannelRetrieveStatus;
//# sourceMappingURL=LicenseHandlers.js.map