"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var flows_1 = require("@ice/dike-core-js/lib/types/flows");
var genericFsm_1 = require("../FSM/genericFsm");
var FSM_1 = require("../FSM");
var dikeClients_1 = require("../dikeClients");
var logger_1 = require("../logger");
var logger = logger_1.provideLogger('OperationHandlers');
var RemoteSignatureFsmChannelInit = /** @class */ (function () {
    function RemoteSignatureFsmChannelInit() {
    }
    RemoteSignatureFsmChannelInit.prototype.handleRequest = function (body) {
        var gFsm = genericFsm_1.GenericFsm.of(flows_1.FlowType.DGS_FLOW_RS_BIND, dikeClients_1.DikeClients.getInstance());
        gFsm.setLogger(logger);
        genericFsm_1.FsmRegistry.getInstance().set(flows_1.FlowType.DGS_FLOW_RS_BIND, gFsm);
        return gFsm.init().then(function () {
            return gFsm.nextState().then(function (v) { return FSM_1.fromState(v); });
        });
    };
    return RemoteSignatureFsmChannelInit;
}());
exports.RemoteSignatureFsmChannelInit = RemoteSignatureFsmChannelInit;
var RemoteSignatureFsmChannelOtp = /** @class */ (function () {
    function RemoteSignatureFsmChannelOtp() {
    }
    RemoteSignatureFsmChannelOtp.prototype.handleRequest = function (body) {
        var genericFsm = genericFsm_1.FsmRegistry.getInstance().get(flows_1.FlowType.DGS_FLOW_RS_BIND);
        var promise = genericFsm.nextState().then(function (v) { return FSM_1.fromState(v); });
        genericFsm.send(flows_1.FlowEvent.DGS_EVT_OTP_INSERTED, body);
        return promise;
    };
    return RemoteSignatureFsmChannelOtp;
}());
exports.RemoteSignatureFsmChannelOtp = RemoteSignatureFsmChannelOtp;
var RemoteSignatureFsmChannelAuth = /** @class */ (function () {
    function RemoteSignatureFsmChannelAuth() {
    }
    RemoteSignatureFsmChannelAuth.prototype.handleRequest = function (body) {
        var genericFsm = genericFsm_1.FsmRegistry.getInstance().get(flows_1.FlowType.DGS_FLOW_RS_BIND);
        var promise = genericFsm.nextState().then(function (v) { return FSM_1.fromState(v); });
        genericFsm.send(flows_1.FlowEvent.DGS_EVT_CREDENTIAL_INSERTED, body);
        return promise;
    };
    return RemoteSignatureFsmChannelAuth;
}());
exports.RemoteSignatureFsmChannelAuth = RemoteSignatureFsmChannelAuth;
var RemoteSignatureDeleteCertificateChannel = /** @class */ (function () {
    function RemoteSignatureDeleteCertificateChannel() {
    }
    RemoteSignatureDeleteCertificateChannel.prototype.handleRequest = function (body) {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.deleteCertificate(body.readerId, body.certificateId);
    };
    return RemoteSignatureDeleteCertificateChannel;
}());
exports.RemoteSignatureDeleteCertificateChannel = RemoteSignatureDeleteCertificateChannel;
var RemoteSignatureJWTCertificateChannel = /** @class */ (function () {
    function RemoteSignatureJWTCertificateChannel() {
    }
    RemoteSignatureJWTCertificateChannel.prototype.handleRequest = function (body) {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.setRSCertificateJWT(body.certificateId, body.jwt);
    };
    return RemoteSignatureJWTCertificateChannel;
}());
exports.RemoteSignatureJWTCertificateChannel = RemoteSignatureJWTCertificateChannel;
var RemoteSignatureFsmChannelJWT = /** @class */ (function () {
    function RemoteSignatureFsmChannelJWT() {
    }
    RemoteSignatureFsmChannelJWT.prototype.handleRequest = function (body) {
        var genericFsm = genericFsm_1.FsmRegistry.getInstance().get(flows_1.FlowType.DGS_FLOW_RS_BIND);
        var promise = genericFsm.nextState().then(function (v) { return FSM_1.fromState(v); });
        genericFsm.send(flows_1.FlowEvent.DGS_EVT_JWT_INSERTED, body);
        return promise;
    };
    return RemoteSignatureFsmChannelJWT;
}());
exports.RemoteSignatureFsmChannelJWT = RemoteSignatureFsmChannelJWT;
//# sourceMappingURL=OperationHandlers.js.map