"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var operators_1 = require("rxjs/operators");
var lodash_1 = require("lodash");
var Ipc_1 = require("../Ipc");
var DikeOperations_1 = require("../shared/DikeOperations");
var flows_1 = require("@ice/dike-core-js/lib/types/flows");
var RenewListener = /** @class */ (function () {
    function RenewListener(core, browserWindow, logger) {
        this.logger = logger;
        core.Messages$.pipe(operators_1.filter(function (value) { return lodash_1.isEqual(value.msg_type, 'renewpinevent'); }), operators_1.tap(function (messages) {
            logger.info("Received message '%s'", JSON.stringify(messages));
            var webServer = core.webServer;
            browserWindow().show();
            if (!Ipc_1.IpcRegistry.Instance.isSubscribed(DikeOperations_1.DikeOperations.CORE_WEB_RENEW)) {
                Ipc_1.IpcRegistry.Instance.bindObservable(DikeOperations_1.DikeOperations.CORE_WEB_RENEW, webServer.renewFlow.FlowData$.pipe(operators_1.filter(function (message) { return lodash_1.isEqual(message.state_type, flows_1.FlowStateType.DGS_STATE_RENEW_WAIT_PIN); })), browserWindow);
            }
        })).subscribe();
    }
    return RenewListener;
}());
exports.RenewListener = RenewListener;
var RenewSendPinChannel = /** @class */ (function () {
    function RenewSendPinChannel(core, logger) {
        this.core = core;
        this.logger = logger;
    }
    RenewSendPinChannel.prototype.handleRequest = function (body) {
        this.logger.info("Received: %s", JSON.stringify(body));
        var renewFlow = this.core.webServer.renewFlow;
        var request = {
            pin: body.pin,
        };
        return renewFlow.send(flows_1.FlowEvent.DGS_EVT_RENEW_PIN_INSERTED, request).then(function (response) { return ({}); });
    };
    return RenewSendPinChannel;
}());
exports.RenewSendPinChannel = RenewSendPinChannel;
//# sourceMappingURL=RenewHandlers.js.map