"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Ipc_1 = require("../Ipc");
var FSM_1 = require("../FSM");
var flows_1 = require("@ice/dike-core-js/lib/types/flows");
var genericFsm_1 = require("../FSM/genericFsm");
var dikeClients_1 = require("../dikeClients");
var request_1 = require("../shared/request");
var requestService_1 = require("../requestService");
var model_1 = require("../model");
var DikeErrors_1 = require("../shared/DikeErrors");
var DikeOperations_1 = require("../shared/DikeOperations");
var logger_1 = require("../logger");
var lodash_1 = require("lodash");
var logger = logger_1.provideLogger('SignatureHandlers');
var FLOW_TYPE = flows_1.FlowType.DGS_FLOW_SIGN;
var flow;
var SignatureFsmChannelInit = /** @class */ (function () {
    function SignatureFsmChannelInit(browserWindowResolver) {
        this.browserWindowResolver = browserWindowResolver;
    }
    SignatureFsmChannelInit.prototype.handleRequest = function (body) {
        var _this = this;
        logger.info('Init signature fsm');
        var gFsm = genericFsm_1.GenericFsm.of(FLOW_TYPE, dikeClients_1.DikeClients.getInstance());
        gFsm.setLogger(logger);
        genericFsm_1.FsmRegistry.getInstance().set(FLOW_TYPE, gFsm);
        return gFsm.init().then(function () {
            Ipc_1.IpcRegistry.Instance.bindObservable(DikeOperations_1.DikeOperations.CORE_SIGNATURE_QUEUE, gFsm.flow.FlowData$, _this.browserWindowResolver);
            return gFsm.nextState().then(function (v) { return FSM_1.fromState(v); });
        });
    };
    return SignatureFsmChannelInit;
}());
exports.SignatureFsmChannelInit = SignatureFsmChannelInit;
var SignatureFsmChannelSign = /** @class */ (function () {
    function SignatureFsmChannelSign(profile) {
        this.profile = profile;
        this.profile = profile;
    }
    SignatureFsmChannelSign.prototype.handleRequest = function (body) {
        var _a, _b, _c, _d, _e, _f;
        var genericFsm = genericFsm_1.FsmRegistry.getInstance().get(FLOW_TYPE);
        if (!request_1.isValidForSignature(body)) {
            return Promise.reject(model_1.DikeError.of(DikeErrors_1.DikeErrors.INVALID_STATUS_SIGNATURE, "Invalid request status " + body.status));
        }
        var noSkipped = SignatureFsmChannelSign.removeSkippedFiles(body);
        var skippedMap = SignatureFsmChannelSign.computeSkippedFilesMap(body);
        var check_contact_update = ((_c = (_b = (_a = this === null || this === void 0 ? void 0 : this.profile) === null || _a === void 0 ? void 0 : _a.modules) === null || _b === void 0 ? void 0 : _b.other) === null || _c === void 0 ? void 0 : _c.dontCheckContactsUpdate) ? false : true;
        console.log("🚀 ~ SignatureFsmChannelSign ~ check_contact_update", { dontCheckContactsUpdate: (_f = (_e = (_d = this.profile) === null || _d === void 0 ? void 0 : _d.modules) === null || _e === void 0 ? void 0 : _e.other) === null || _f === void 0 ? void 0 : _f.dontCheckContactsUpdate, check_contact_update: check_contact_update });
        var payload = __assign(__assign({}, noSkipped), { check_contact_update: check_contact_update, 
            // TODO: only for demo! remove on production
            //force_contact_update: !noSkipped.counter,
            authenticator: flows_1.SignAuthenticator[noSkipped.authenticator] });
        return genericFsm.send(flows_1.FlowEvent.DGS_EVT_SIGNATURE_PARAMS_INSERTED, payload).then(function () { return ({}); });
    };
    SignatureFsmChannelSign.removeSkippedFiles = function (body) {
        return request_1.updateCoreSignatureBatchRequestFiles(body, body.files.filter(function (value) { return value.overWriteStatus !== 'SKIP'; }));
    };
    SignatureFsmChannelSign.computeSkippedFilesMap = function (body) {
        return body.files.map(function (value) { return value.overWriteStatus !== 'SKIP'; });
    };
    return SignatureFsmChannelSign;
}());
exports.SignatureFsmChannelSign = SignatureFsmChannelSign;
var SignatureChannelValidateRequest = /** @class */ (function () {
    function SignatureChannelValidateRequest() {
    }
    SignatureChannelValidateRequest.prototype.handleRequest = function (body) {
        if (body.status === 'NEW') {
            return requestService_1.default.validateRequest(body);
        }
        else {
            return Promise.reject(model_1.DikeError.of(DikeErrors_1.DikeErrors.INVALID_STATUS_VALIDATION, "Invalid request status " + body.status));
        }
    };
    return SignatureChannelValidateRequest;
}());
exports.SignatureChannelValidateRequest = SignatureChannelValidateRequest;
var SignatureFsmChannelRetrieveResult = /** @class */ (function () {
    function SignatureFsmChannelRetrieveResult(analyticsEventHandler, deviceListChannel) {
        this.analyticsEventHandler = analyticsEventHandler;
        this.deviceListChannel = deviceListChannel;
    }
    SignatureFsmChannelRetrieveResult.prototype.handleRequest = function (body) {
        var _this = this;
        return new Promise(function (resolve) {
            var parsed = requestService_1.default.parseResults(body.request, body.result);
            var okCount = lodash_1.size(lodash_1.filter(parsed.files, function (value) { return (value.operationStatus = 'SUCCESS'); }));
            _this.sendDeviceUsedStatistics(parsed, okCount);
            _this.sendCustomDeviceUsedStatistics(parsed.selected_reader, okCount);
            _this.sendSignatureTypeStatistics(parsed, okCount);
            _this.sendCertificateUsedStatistics(parsed.certificate_id, okCount);
            _this.sendTimestampStatistics(parsed, okCount);
            resolve(parsed);
        });
    };
    SignatureFsmChannelRetrieveResult.prototype.sendDeviceUsedStatistics = function (parsed, okSignatures) {
        var isLocal = parsed.selected_reader === -1 || parsed.selected_reader === -4;
        var isRemote = parsed.selected_reader === 0;
        var isDevice = parsed.selected_reader >= 1;
        var isSpid = !!(parsed === null || parsed === void 0 ? void 0 : parsed.certificate);
        console.log("🚀 ~ sendDeviceUsedStatistics ~ parsed:", parsed, { isLocal: isLocal, isRemote: isRemote, isDevice: isDevice, isSpid: isSpid });
        if (isSpid) {
            this.analyticsEventHandler.sendOneShotSignature(okSignatures);
        }
        else if (isRemote) {
            this.analyticsEventHandler.sendRemoteSignature(okSignatures);
        }
        else if (isLocal) {
            this.analyticsEventHandler.sendLocalSignature(okSignatures);
        }
        else if (isDevice) {
            this.analyticsEventHandler.sendDeviceSignature(okSignatures);
        }
        else {
            console.warn("Invalid signature type");
        }
    };
    SignatureFsmChannelRetrieveResult.prototype.sendCustomDeviceUsedStatistics = function (reader_index, okSignatures) {
        return __awaiter(this, void 0, void 0, function () {
            var devices, reader, isCustom, atr;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.deviceListChannel.handleRequest({ forceRescan: false })];
                    case 1:
                        devices = _a.sent();
                        reader = lodash_1.find(devices.readers, function (device) { return device.index === reader_index; });
                        if (!lodash_1.isNil(reader)) {
                            isCustom = reader.is_custom;
                            atr = reader.ATR;
                            if (isCustom) {
                                this.analyticsEventHandler.sendCustomDeviceSignature(okSignatures, atr);
                            }
                        }
                        else {
                            console.warn("No reader found for statistics " + reader_index);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    SignatureFsmChannelRetrieveResult.prototype.sendTimestampStatistics = function (parsed, okSignatures) {
        var isTimestamp = parsed.timestamp;
        if (isTimestamp) {
            this.analyticsEventHandler.sendTimestamp(okSignatures);
        }
    };
    SignatureFsmChannelRetrieveResult.prototype.sendSignatureTypeStatistics = function (parsed, okSignatures) {
        switch (parsed.signFormat) {
            case flows_1.SignFormat.DGS_SIGN_TYPE_CADES:
                return this.analyticsEventHandler.sendCadesSignature(okSignatures);
            case flows_1.SignFormat.DGS_SIGN_TYPE_PADES:
                return this.analyticsEventHandler.sendPadesSignature(okSignatures);
            case flows_1.SignFormat.DGS_SIGN_TYPE_XADES:
                return this.analyticsEventHandler.sendXadesSignature(okSignatures);
        }
    };
    SignatureFsmChannelRetrieveResult.prototype.sendCertificateUsedStatistics = function (certificate_id, okSignatures) {
        return __awaiter(this, void 0, void 0, function () {
            var devices, certs, cert, issuerCN;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.deviceListChannel.handleRequest({ forceRescan: false })];
                    case 1:
                        devices = _a.sent();
                        certs = lodash_1.flatMap(devices.readers, function (reader) { return reader.certificates; });
                        cert = lodash_1.find(certs, function (cert) { return cert.id === certificate_id; });
                        if (!lodash_1.isNil(cert)) {
                            issuerCN = lodash_1.get(cert, 'x509.issuerCN');
                            this.analyticsEventHandler.sendCertificateCommonName(issuerCN, okSignatures);
                        }
                        else {
                            console.warn("No certificate  found for statistics " + certificate_id);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    return SignatureFsmChannelRetrieveResult;
}());
exports.SignatureFsmChannelRetrieveResult = SignatureFsmChannelRetrieveResult;
var SignatureFsmChannelStart = /** @class */ (function () {
    function SignatureFsmChannelStart() {
    }
    SignatureFsmChannelStart.prototype.handleRequest = function (body) {
        var genericFsm = genericFsm_1.FsmRegistry.getInstance().get(FLOW_TYPE);
        return genericFsm.send(flows_1.FlowEvent.DGS_EVT_START_SIGN, {});
    };
    return SignatureFsmChannelStart;
}());
exports.SignatureFsmChannelStart = SignatureFsmChannelStart;
var SignatureOtpSend = /** @class */ (function () {
    function SignatureOtpSend() {
    }
    SignatureOtpSend.prototype.handleRequest = function (body) {
        var genericFsm = genericFsm_1.FsmRegistry.getInstance().get(FLOW_TYPE);
        return genericFsm.send(flows_1.FlowEvent.DGS_EVT_OTP_INSERTED, { otp: body });
    };
    return SignatureOtpSend;
}());
exports.SignatureOtpSend = SignatureOtpSend;
var SignatureResendSms = /** @class */ (function () {
    function SignatureResendSms() {
    }
    SignatureResendSms.prototype.handleRequest = function (body) {
        var genericFsm = genericFsm_1.FsmRegistry.getInstance().get(FLOW_TYPE);
        return genericFsm.send(flows_1.FlowEvent.DGS_EVT_RESEND_OTP, {});
    };
    return SignatureResendSms;
}());
exports.SignatureResendSms = SignatureResendSms;
var SignaturePollAuthorization = /** @class */ (function () {
    function SignaturePollAuthorization() {
    }
    SignaturePollAuthorization.prototype.handleRequest = function (body) {
        var genericFsm = genericFsm_1.FsmRegistry.getInstance().get(FLOW_TYPE);
        return genericFsm.send(flows_1.FlowEvent.DGS_EVT_POLL_AUTHORIZATION, {});
    };
    return SignaturePollAuthorization;
}());
exports.SignaturePollAuthorization = SignaturePollAuthorization;
var SignatureAbortChannel = /** @class */ (function () {
    function SignatureAbortChannel() {
    }
    SignatureAbortChannel.prototype.handleRequest = function (body) {
        var genericFsm = genericFsm_1.FsmRegistry.getInstance().get(FLOW_TYPE);
        return genericFsm.flow.abort().then(function (value) { return (!value ? {} : value); });
    };
    return SignatureAbortChannel;
}());
exports.SignatureAbortChannel = SignatureAbortChannel;
var SignatureContactsSend = /** @class */ (function () {
    function SignatureContactsSend() {
    }
    SignatureContactsSend.prototype.handleRequest = function (body) {
        if (body === void 0) { body = { email: '', mobile: '' }; }
        var genericFsm = genericFsm_1.FsmRegistry.getInstance().get(FLOW_TYPE);
        return genericFsm.send(flows_1.FlowEvent.DGS_EVT_CONTACT_UPDATE, body);
    };
    return SignatureContactsSend;
}());
exports.SignatureContactsSend = SignatureContactsSend;
//# sourceMappingURL=SignatureHandlers.js.map