"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
//@ts-nocheck
var flows_1 = require("@ice/dike-core-js/lib/types/flows");
var dikeClients_1 = require("../dikeClients");
var flows_2 = require("@ice/dike-core-js/lib/types/flows");
var logger_1 = require("../logger");
var logger = logger_1.provideLogger('VscrSignatureHandlers');
var VscrInsertCard = /** @class */ (function () {
    function VscrInsertCard() {
    }
    VscrInsertCard.prototype.handleRequest = function (body) {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.insertVSCRCard();
    };
    return VscrInsertCard;
}());
exports.VscrInsertCard = VscrInsertCard;
var VscrRemoveCard = /** @class */ (function () {
    function VscrRemoveCard() {
    }
    VscrRemoveCard.prototype.handleRequest = function (body) {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.removeVSCRCard();
    };
    return VscrRemoveCard;
}());
exports.VscrRemoveCard = VscrRemoveCard;
var VscrGetStatusCard = /** @class */ (function () {
    function VscrGetStatusCard() {
    }
    VscrGetStatusCard.prototype.handleRequest = function (body) {
        var instance = dikeClients_1.DikeClients.getInstance();
        return instance.getVSCRStatus();
    };
    return VscrGetStatusCard;
}());
exports.VscrGetStatusCard = VscrGetStatusCard;
var VscrSignatureSendAuthChannel = /** @class */ (function () {
    function VscrSignatureSendAuthChannel() {
    }
    VscrSignatureSendAuthChannel.prototype.handleRequest = function (body) {
        logger.info("Sending authentication params: %s", logger_1.safeJsonStringify(body));
        var data = {
            authenticator: flows_2.SignAuthenticator[body.authenticator]
        };
        return dikeClients_1.DikeClients.getInstance().webServer.vscrSignFlow.send(flows_1.FlowEvent.DGS_EVT_VSCR_AUTHENTICATOR, data);
    };
    return VscrSignatureSendAuthChannel;
}());
exports.VscrSignatureSendAuthChannel = VscrSignatureSendAuthChannel;
var VscrSignatureStartSigningChannel = /** @class */ (function () {
    function VscrSignatureStartSigningChannel() {
    }
    VscrSignatureStartSigningChannel.prototype.handleRequest = function (body) {
        logger.info("Start signing %s", logger_1.safeJsonStringify(body));
        return dikeClients_1.DikeClients.getInstance().webServer.vscrSignFlow.send(flows_1.FlowEvent.DGS_EVT_START_SIGN);
    };
    return VscrSignatureStartSigningChannel;
}());
exports.VscrSignatureStartSigningChannel = VscrSignatureStartSigningChannel;
var VscrSignatureOtpSend = /** @class */ (function () {
    function VscrSignatureOtpSend() {
    }
    VscrSignatureOtpSend.prototype.handleRequest = function (body) {
        logger.info("Sending OTP");
        return dikeClients_1.DikeClients.getInstance().webServer.vscrSignFlow.send(flows_1.FlowEvent.DGS_EVT_OTP_INSERTED, { otp: body });
    };
    return VscrSignatureOtpSend;
}());
exports.VscrSignatureOtpSend = VscrSignatureOtpSend;
var VscrSignaturePollAuthorization = /** @class */ (function () {
    function VscrSignaturePollAuthorization() {
    }
    VscrSignaturePollAuthorization.prototype.handleRequest = function (body) {
        logger.info("Polling authorization");
        var vscrSignFlow = dikeClients_1.DikeClients.getInstance().webServer.vscrSignFlow;
        return vscrSignFlow.send(flows_1.FlowEvent.DGS_EVT_POLL_AUTHORIZATION).then(function () { return ({}); });
    };
    return VscrSignaturePollAuthorization;
}());
exports.VscrSignaturePollAuthorization = VscrSignaturePollAuthorization;
var VscrSignatureResendSms = /** @class */ (function () {
    function VscrSignatureResendSms() {
    }
    VscrSignatureResendSms.prototype.handleRequest = function (body) {
        logger.info("Resend SMS");
        var vscrSignFlow = dikeClients_1.DikeClients.getInstance().webServer.vscrSignFlow;
        return vscrSignFlow.send(flows_1.FlowEvent.DGS_EVT_RESEND_OTP).then(function () { return ({}); });
    };
    return VscrSignatureResendSms;
}());
exports.VscrSignatureResendSms = VscrSignatureResendSms;
var VscrSignatureAbort = /** @class */ (function () {
    function VscrSignatureAbort() {
    }
    VscrSignatureAbort.prototype.handleRequest = function (body) {
        var vscrSignFlow = dikeClients_1.DikeClients.getInstance().webServer.vscrSignFlow;
        return vscrSignFlow.abort().then(function () { return ({}); });
    };
    return VscrSignatureAbort;
}());
exports.VscrSignatureAbort = VscrSignatureAbort;
//# sourceMappingURL=VscrHandler.js.map