"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var JobQueueChannel = /** @class */ (function () {
    function JobQueueChannel(jobsQueue) {
        this.jobsQueue = jobsQueue;
    }
    JobQueueChannel.prototype.handleRequest = function (body) {
        var jobCommand = this.jobsQueue.peekMaxPriority();
        if (!lodash_1.isNil(jobCommand)) {
            if (jobCommand.priority >= body.priority) {
                return Promise.resolve({ next: this.jobsQueue.getMaxPriority(), hasNext: true });
            }
            else {
                return Promise.resolve({
                    next: null,
                    hasNext: false,
                });
            }
        }
        else {
            return Promise.resolve({
                next: null,
                hasNext: false,
            });
        }
    };
    return JobQueueChannel;
}());
exports.JobQueueChannel = JobQueueChannel;
var AddJobQueueChannel = /** @class */ (function () {
    function AddJobQueueChannel(jobQueueProvider, logger) {
        this.jobQueueProvider = jobQueueProvider;
        this.logger = logger;
    }
    AddJobQueueChannel.prototype.handleRequest = function (body) {
        this.jobQueueProvider.add(body.command);
        return Promise.resolve({ status: 'ok' });
    };
    return AddJobQueueChannel;
}());
exports.AddJobQueueChannel = AddJobQueueChannel;
//# sourceMappingURL=jobQueueChannel.js.map