"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var immutable_1 = require("immutable");
var lodash_1 = require("lodash");
var JobQueueProvider = /** @class */ (function () {
    function JobQueueProvider() {
        this.jobs = immutable_1.List();
    }
    Object.defineProperty(JobQueueProvider.prototype, "length", {
        get: function () {
            return this.jobs.size;
        },
        enumerable: true,
        configurable: true
    });
    JobQueueProvider.prototype.peekMaxPriority = function () {
        return this.jobs.first(null);
    };
    JobQueueProvider.prototype.asArray = function () {
        return this.jobs.toArray();
    };
    JobQueueProvider.prototype.getMaxPriority = function () {
        var jc = this.jobs.first();
        this.jobs = this.jobs.shift();
        return jc;
    };
    JobQueueProvider.prototype.add = function (command) {
        if (command.unique) {
            this.pushUnique(command);
        }
        else {
            this.push(command);
        }
    };
    JobQueueProvider.prototype.push = function (command) {
        var unsorted = this.jobs.push(command);
        this.jobs = unsorted.sort(function (a, b) { return b.priority - a.priority; });
    };
    JobQueueProvider.prototype.pushUnique = function (command) {
        var jobTargetsT = this.jobs.find(function (value) { return lodash_1.isEqual(value.jobType, command.jobType); });
        if (lodash_1.isNil(jobTargetsT)) {
            this.push(command);
        }
    };
    return JobQueueProvider;
}());
exports.JobQueueProvider = JobQueueProvider;
//# sourceMappingURL=jobQueueProvider.js.map