"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var electron_1 = require("electron");
var path = require('path');
function resolvePortableRoot() {
    if (lodash_1.isEqual(process.platform, 'darwin')) {
        return path.join(path.parse(electron_1.app.getAppPath()).dir, '../../../../../../');
    }
    else {
        return path.join(path.parse(electron_1.app.getAppPath()).dir, '../../../../');
    }
}
exports.resolvePortableRoot = resolvePortableRoot;
function resolvePortableConfigurationPath() {
    return lodash_1.cond([
        [isWin32, lodash_1.constant(path.join(resolvePortableRoot(), 'Configurazione', 'Windows', 'GoSignDesktopBK'))],
        [isDarwin, lodash_1.constant(path.join(resolvePortableRoot(), 'Configurazione', 'OSX', 'GoSignDesktopBK'))],
        [lodash_1.stubTrue, function () {
                throw new Error('Unsupported Os');
            }],
    ])(process.platform);
}
exports.resolvePortableConfigurationPath = resolvePortableConfigurationPath;
var isDarwin = function (os) { return lodash_1.isEqual(os, 'darwin'); };
var isWin32 = function (os) { return lodash_1.isEqual(os, 'win32'); };
//# sourceMappingURL=ResolvePortableRoot.js.map