"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Ipc_1 = require("./Ipc");
var DikeOperations_1 = require("./shared/DikeOperations");
var rxjs_1 = require("rxjs");
var RoutingService = /** @class */ (function () {
    function RoutingService(bw) {
        this.bw = bw;
        this._queue = new rxjs_1.Subject();
        Ipc_1.IpcRegistry.Instance.bindObservable(DikeOperations_1.DikeOperations.ROUTING, this._queue, function () { return bw; });
    }
    RoutingService.prototype.openRenewPage = function () {
        console.log('Opening Renew Page');
        this._queue.next({
            outlet: 'configurationModal',
            page: ['settings', 'certificates']
        });
    };
    RoutingService.prototype.openAboutPage = function () {
        console.log('Opening About Page');
        var closeConfiguration = {
            outlet: 'configurationModal',
            page: null,
        };
        var openAbout = {
            outlet: '',
            page: ['about'],
        };
        this._queue.next(closeConfiguration);
        this._queue.next(openAbout);
    };
    return RoutingService;
}());
exports.RoutingService = RoutingService;
//# sourceMappingURL=RoutingService.js.map