"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var logger_1 = require("./logger");
var Registry = require("winreg");
var logger = logger_1.provideLogger('registry');
function $call(registry, fn) {
    var args = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        args[_i - 2] = arguments[_i];
    }
    return new Promise(function (resolve, reject) {
        registry[fn].apply(registry, __spreadArrays(args, [function (err) {
                if (err) {
                    reject(new Error(err));
                }
                else {
                    var result = Array.prototype.splice.apply(arguments, [1]);
                    resolve.apply(void 0, result);
                }
            }]));
    });
}
var $create = function (registry) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    return $call.apply(void 0, __spreadArrays([registry, 'create'], args)).then(function () { logger.info("Finita create " + registry.key + ',' + args.join(',')); });
};
var $set = function (registry) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    return $call.apply(void 0, __spreadArrays([registry, 'set'], args)).then(function () { logger.info("Finita set " + registry.key + ',' + args.join(',')); });
};
var $destroy = function (registry) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    return $call.apply(void 0, __spreadArrays([registry, 'destroy'], args)).then(function () { logger.info("Finita destroy " + registry.key + ',' + args.join(',')); });
};
var $remove = function (registry) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    return $call.apply(void 0, __spreadArrays([registry, 'remove'], args)).then(function () { logger.info("Finita remove " + registry.key + ',' + args.join(',')); });
};
;
function deleteKeys(keys) {
    return __awaiter(this, void 0, void 0, function () {
        var keyPromises, _i, keys_1, k, r;
        return __generator(this, function (_a) {
            keyPromises = [];
            for (_i = 0, keys_1 = keys; _i < keys_1.length; _i++) {
                k = keys_1[_i];
                r = new Registry(k);
                keyPromises.push($destroy(r));
            }
            return [2 /*return*/, Promise.all(keyPromises)];
        });
    });
}
exports.deleteKeys = deleteKeys;
function createKeys(keys) {
    return __awaiter(this, void 0, void 0, function () {
        var keyPromises, _i, keys_2, k, r;
        return __generator(this, function (_a) {
            keyPromises = [];
            for (_i = 0, keys_2 = keys; _i < keys_2.length; _i++) {
                k = keys_2[_i];
                r = new Registry(k);
                keyPromises.push($create(r));
                if (k.MUIVerb) {
                    keyPromises.push($set(r, 'MUIVerb', Registry.REG_SZ, k.MUIVerb));
                }
                if (k.ExtendedSubCommandsKey) {
                    keyPromises.push($set(r, 'ExtendedSubCommandsKey', Registry.REG_SZ, k.ExtendedSubCommandsKey));
                }
                if (k.MultiSelectModel) {
                    keyPromises.push($set(r, 'MultiSelectModel', Registry.REG_SZ, k.MultiSelectModel));
                }
                if (k.Default) {
                    keyPromises.push($set(r, Registry.DEFAULT_VALUE, Registry.REG_SZ, k.Default));
                }
            }
            return [2 /*return*/, Promise.all(keyPromises)];
        });
    });
}
exports.createKeys = createKeys;
function cleanStartupRegistry() {
    return __awaiter(this, void 0, void 0, function () {
        var keyPromises, regKey;
        return __generator(this, function (_a) {
            keyPromises = [];
            regKey = new Registry({
                hive: Registry.HKCU,
                key: '\\Software\\Microsoft\\Windows\\CurrentVersion\\Run'
            });
            regKey.values(function (err, items) {
                if (err) {
                    console.log('ERROR: ' + err);
                }
                else {
                    for (var i = 0; i < items.length; i++) {
                        var valueName = items[i].name;
                        if (/.*app-[\d\.]+\\GoSignDesktop.exe$/.test(valueName)) {
                            keyPromises.push($remove(regKey, valueName));
                        }
                    }
                }
            });
            return [2 /*return*/, Promise.all(keyPromises)];
        });
    });
}
exports.cleanStartupRegistry = cleanStartupRegistry;
//# sourceMappingURL=registry.js.map