const Platform = require("os").type();
const Arch = process.env.npm_config_arch;
const fs = require("fs");
const path = require("path");
const Package = require("./package.json");
const folder = __dirname;

function getModuleToInstall() {

    let _moduleToInstall;
    switch (Platform) {
        //Mac
        case "Darwin":
            _moduleToInstall = "@ice/dike-core-osx";
            break;

            //Windows
        case "Windows_NT":
            _moduleToInstall = "@ice/dike-core-win" + (Arch == "x64" ? "64" : "");
            break;

            //Linux
        case "Linux":
            _moduleToInstall = "@ice/dike-core-linux";
            break;

        default:
            _moduleToInstall = " ";
            break;
    }

    console.log("Platform", Platform, "moduleToInstall", _moduleToInstall)

    return _moduleToInstall;
}

async function AddCore() {

    console.log("AddCore");
    moduleToInstall = getModuleToInstall();
    const version = await getInstalledVersion(moduleToInstall);

    console.log("AddCore", { version })

    Package.dependencies[moduleToInstall] = version;

    fs.writeFileSync(path.join(folder, 'package.json'), JSON.stringify(Package, null, 2));
}

async function getInstalledVersion(moduleToInstall) {
    let installedVersion = false;
    try {
        installedVersion = require(`${moduleToInstall}/package.json`).version;
    } catch (err) {
        console.error(err);
        return "";
    }

    console.log("getinstalledVersion -> installedVersion", installedVersion)
    return installedVersion.trim();

}

AddCore();
