"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.Base64encode = exports.Base64decode = exports.getAllMethodNames = exports.Promisify = exports.DgsError = exports.sendSuccess = exports.sendError = exports.sendJsonString = void 0;
var Bluebird = require("bluebird");
var error_codes_1 = require("./types/error_codes");
var sendJsonString = function (json) {
    var stringified = JSON.stringify(json);
    //console.log("sendJsonString -> stringified", stringified)
    console.dir(json, { depth: undefined });
    return stringified;
};
exports.sendJsonString = sendJsonString;
var sendError = function (message, errorCode) {
    var err = new DgsError(message, errorCode);
    throw err;
};
exports.sendError = sendError;
var sendSuccess = function (message, errorCode) {
    if (errorCode === void 0) { errorCode = error_codes_1.ErrorCodes.DGS_OK; }
    var succes = {
        message: message,
        code: errorCode
    };
    return message;
};
exports.sendSuccess = sendSuccess;
var DgsError = /** @class */ (function (_super) {
    __extends(DgsError, _super);
    function DgsError(message, code) {
        var _this = _super.call(this) || this;
        if (code) {
            _this.name = "".concat(code);
            _this.code = code;
            _this.message = message;
        }
        return _this;
    }
    return DgsError;
}(Error));
exports.DgsError = DgsError;
var Promisify = function (method) {
    return Bluebird.promisify(method.async);
};
exports.Promisify = Promisify;
var getAllMethodNames = function (obj) {
    var props = [];
    do {
        var l = Object.getOwnPropertyNames(obj)
            .concat(Object.getOwnPropertySymbols(obj).map(function (s) { return s.toString(); }))
            .sort()
            .filter(function (p, i, arr) {
            return typeof obj[p] === 'function' && //only the methods
                p !== 'constructor' && //not the constructor
                (i == 0 || p !== arr[i - 1]) && //not overriding in this prototype
                props.indexOf(p) === -1;
        } //not overridden in a child
        );
        props = props.concat(l);
    } while ((obj = Object.getPrototypeOf(obj)) && //walk-up the prototype chain
        Object.getPrototypeOf(obj) //not the the Object prototype methods (hasOwnProperty, etc...)
    );
    return props;
};
exports.getAllMethodNames = getAllMethodNames;
var Base64decode = function (base64string) {
    var buff = Buffer.from(base64string, 'base64');
    var str = buff.toString('utf-8');
    //console.log(str);
    return str;
};
exports.Base64decode = Base64decode;
var Base64encode = function (strinToEncode) {
    var buff = Buffer.from(strinToEncode, 'utf-8');
    // decode buffer as Base64
    var base64 = buff.toString('base64');
    // console.log("Base64encode -> base64", base64)
    return base64;
};
exports.Base64encode = Base64encode;
//# sourceMappingURL=Helpers.js.map