"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MethodsList = exports.NativeMethods = void 0;
var types_1 = require("./types");
var DGS_CORE_P = types_1.default.pointer;
var DGS_FLOW_P = types_1.default.pointer;
var DGS_JSON_BUFFER_P = types_1.default.pointer;
var DGS_RESULT = types_1.default.int;
var JSON_PAYLOAD = types_1.default.string;
var DGS_FLOW_TYPE = types_1.default.int;
var DGS_FLOW_EVENT = types_1.default.int;
var DGS_COUNTRY_CODE = types_1.default.int;
var CHAR = types_1.default.char;
var DGS_GOSIGN_URL = types_1.default.int;
var DGS_URLS = types_1.default.int;
var DGS_EIDG_CONFIGURATION = types_1.default.int;
var DGS_LOGIN_TYPE = types_1.default.int;
var DGS_PAYMENT_TYPE = types_1.default.int;
var DGS_COUPON_TYPE = types_1.default.int;
//start
exports.NativeMethods = {
    'dgs_init_statics': [types_1.default.void, [types_1.default.string]],
    'dgs_core_init': [DGS_CORE_P, [types_1.default.string, types_1.default.string, types_1.default.string]],
    'dgs_core_version': [types_1.default.string, []],
    'dgs_core_destroy': [types_1.default.void, [DGS_CORE_P]],
    'dgs_select_environment': [types_1.default.void, [types_1.default.int]],
    'dgs_set_log_level': [types_1.default.void, [types_1.default.int]],
    'dgs_err_str': [types_1.default.string, [types_1.default.int]],
    //Get Devices
    'dgs_device_snapshot_get': [DGS_RESULT, [DGS_CORE_P, types_1.default.pointerOfPointer]],
    'dgs_device_snapshot_ext': [DGS_RESULT, [DGS_CORE_P, types_1.default.uchar, types_1.default.int, types_1.default.pointerOfPointer]],
    //Common JSON
    'dgs_json_value': [types_1.default.string, [DGS_JSON_BUFFER_P]],
    'dgs_json_value_free': [types_1.default.void, [DGS_JSON_BUFFER_P]],
    //Configuration
    'dgs_configuration_get': [types_1.default.void, [DGS_CORE_P, types_1.default.pointerOfPointer]],
    'dgs_configuration_set': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string]],
    'dgs_core_reloadcfg': [types_1.default.void, [DGS_CORE_P]],
    //Messages
    'dgs_message_queue_pop': [DGS_RESULT, [DGS_CORE_P, types_1.default.pointerOfPointer]],
    'dgs_message_queue_echo': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string, types_1.default.string]],
    'dgs_pcscmonitor_run': [DGS_RESULT, [DGS_CORE_P]],
    'dgs_pcscmonitor_stop': [DGS_RESULT, [DGS_CORE_P]],
    //Reader function 3 errori pin => puk
    //
    'dgs_test_pin': [types_1.default.DGS_RESULT, [DGS_CORE_P, types_1.default.int, types_1.default.string]],
    'dgs_change_pin': [types_1.default.DGS_RESULT, [DGS_CORE_P, types_1.default.int, types_1.default.string, types_1.default.string]],
    'dgs_unlock_pin': [types_1.default.DGS_RESULT, [DGS_CORE_P, types_1.default.int, types_1.default.string, types_1.default.string]],
    'dgs_unlock_ce_pin': [types_1.default.DGS_RESULT, [DGS_CORE_P, types_1.default.int, types_1.default.string, types_1.default.string]],
    'dgs_activate_card': [types_1.default.DGS_RESULT, [DGS_CORE_P, types_1.default.int, types_1.default.string, types_1.default.string]],
    'dgs_activate_ce_card': [types_1.default.DGS_RESULT, [DGS_CORE_P, types_1.default.int, types_1.default.string, types_1.default.string, types_1.default.string]],
    'dgs_set_double_pin': [types_1.default.DGS_RESULT, [DGS_CORE_P, types_1.default.int, types_1.default.bool]],
    'dgs_customp11_set': [types_1.default.DGS_RESULT, [DGS_CORE_P, types_1.default.int, types_1.default.string, types_1.default.string]],
    'dgs_customp11_unset': [types_1.default.DGS_RESULT, [DGS_CORE_P]],
    //Events Flow
    'dgs_flow_start': [DGS_FLOW_P, [DGS_CORE_P, DGS_FLOW_TYPE]],
    'dgs_flow_state': [DGS_RESULT, [DGS_FLOW_P, DGS_JSON_BUFFER_P]],
    'dgs_flow_post_event': [DGS_RESULT, [DGS_FLOW_P, DGS_FLOW_EVENT, JSON_PAYLOAD]],
    'dgs_flow_abort_event_process': [types_1.default.void, [DGS_FLOW_P]],
    'dgs_flow_free': [types_1.default.void, [DGS_FLOW_P]],
    //Certificates
    'dgs_get_timestamp_account': [DGS_RESULT, [DGS_CORE_P, types_1.default.bool, DGS_JSON_BUFFER_P]],
    'dgs_delete_timestamp_account': [DGS_RESULT, [DGS_CORE_P]],
    'dgs_delete_rs_certificate': [DGS_RESULT, [DGS_CORE_P, types_1.default.string]],
    'dgs_set_rs_account_jwt': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string]],
    //License
    'dgs_license_bind': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, DGS_JSON_BUFFER_P]],
    'dgs_license_get_status': [DGS_RESULT, [DGS_CORE_P, DGS_JSON_BUFFER_P]],
    'dgs_license_unbind': [DGS_RESULT, [DGS_CORE_P, types_1.default.string]],
    'dgs_license_remove': [DGS_RESULT, [DGS_CORE_P]],
    //TSL
    'dgs_tsl_checkupdates': [DGS_RESULT, [DGS_CORE_P, DGS_JSON_BUFFER_P]],
    'dgs_tsl_update': [DGS_RESULT, [DGS_CORE_P, types_1.default.string]],
    'dgs_tsl_get': [DGS_RESULT, [DGS_CORE_P, DGS_JSON_BUFFER_P]],
    'dgs_tsl_add': [DGS_RESULT, [DGS_CORE_P, types_1.default.int]],
    'dgs_tsl_remove': [DGS_RESULT, [DGS_CORE_P, types_1.default.int]],
    'dgs_tsl_reload': [DGS_RESULT, [DGS_CORE_P]],
    //dgs_add_pkcs12_file
    'dgs_add_pkcs12_file': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string, types_1.default.bool]],
    'dgs_remove_pkcs12_file': [DGS_RESULT, [DGS_CORE_P, types_1.default.string]],
    'dgs_verify_file': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string, types_1.default.string, DGS_JSON_BUFFER_P]],
    'dgs_extract_file': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string]],
    'dgs_extract_files': [DGS_RESULT, [DGS_CORE_P, types_1.default.string]],
    //oauth
    'dgs_oauth_get_url': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, DGS_LOGIN_TYPE, DGS_JSON_BUFFER_P]],
    'dgs_oauth_get_identity': [DGS_RESULT, [DGS_CORE_P, types_1.default.bool, DGS_JSON_BUFFER_P]],
    'dgs_oauth_authorize': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string]],
    'dgs_oauth_login': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string]],
    'dgs_oauth_logout': [DGS_RESULT, [DGS_CORE_P]],
    'dgs_oauth_select_associations': [DGS_RESULT, [DGS_CORE_P, types_1.default.string]],
    //gosign
    'dgs_gosign_load_url': [DGS_RESULT, [DGS_CORE_P, DGS_GOSIGN_URL, types_1.default.string, DGS_JSON_BUFFER_P]],
    //ATL
    'dgs_atl_get': [DGS_RESULT, [DGS_CORE_P, types_1.default.bool, DGS_JSON_BUFFER_P]],
    //TIMESTAMP
    'dgs_associate_timestamp': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string, types_1.default.string, types_1.default.int]],
    'dgs_separate_timestamp': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string, DGS_JSON_BUFFER_P]],
    'dgs_create_HTML_report': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string, types_1.default.string, types_1.default.string]],
    //CERT CHRONO
    'dgs_certchrono_get_certificates': [DGS_RESULT, [DGS_CORE_P, DGS_JSON_BUFFER_P]],
    'dgs_certchrono_remove_certificate': [DGS_RESULT, [DGS_CORE_P, types_1.default.string]],
    'dgs_certchrono_remove_certificates': [DGS_RESULT, [DGS_CORE_P]],
    'dgs_certchrono_remove_valid_certificates': [DGS_RESULT, [DGS_CORE_P]],
    'dgs_certchrono_remove_expired_certificates': [DGS_RESULT, [DGS_CORE_P]],
    'dgs_certchrono_set_last_reminded': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string]],
    'dgs_certchrono_set_next_remind': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string]],
    'dgs_certchrono_set_last_renew_notify': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string]],
    'dgs_certchrono_set_last_mail_update': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string]],
    'dgs_certchrono_set_mail_update_count': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.int]],
    'dgs_certchrono_set_cert_renew_status': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.int]],
    //EID Gateway
    'dgs_eid_get_url': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, DGS_EIDG_CONFIGURATION, DGS_JSON_BUFFER_P]],
    'dgs_eid_authorize': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string, DGS_JSON_BUFFER_P]],
    'dgs_eid_oneshot_count': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, DGS_JSON_BUFFER_P]],
    'dgs_eid_oneshot_emission': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string, types_1.default.int, types_1.default.string, types_1.default.string, types_1.default.string, DGS_JSON_BUFFER_P]],
    //Validation API
    'dgs_qualified_verify_generate_report': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string, DGS_PAYMENT_TYPE, types_1.default.string, DGS_JSON_BUFFER_P]],
    'dgs_qualified_verify_sign_report': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string, types_1.default.string, DGS_PAYMENT_TYPE, types_1.default.string]],
    'dgs_qualified_verify_count': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, DGS_JSON_BUFFER_P]],
    //Certstore
    'dgs_certstore_register': [DGS_RESULT, [DGS_CORE_P, types_1.default.string]],
    //Utility
    'dgs_makezip': [DGS_RESULT, [DGS_CORE_P, types_1.default.string]],
    'dgs_core_session_params': [DGS_RESULT, [DGS_CORE_P, DGS_JSON_BUFFER_P]],
    'dgs_check_pdf': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, DGS_JSON_BUFFER_P]],
    'dgs_pdfimage_combine': [DGS_RESULT, [DGS_CORE_P, types_1.default.string, types_1.default.string, types_1.default.string]],
    'dgs_check_connection': [DGS_RESULT, [DGS_CORE_P]],
    'dgs_check_coupon': [DGS_RESULT, [DGS_CORE_P, DGS_COUPON_TYPE, types_1.default.string]],
    'dgs_get_url': [DGS_RESULT, [DGS_CORE_P, DGS_URLS, DGS_JSON_BUFFER_P]],
    'dgs_save_verbose_logs': [DGS_RESULT, [DGS_CORE_P, types_1.default.string]],
};
//end
exports.MethodsList = Object.keys(exports.NativeMethods).map(function (method, index) {
    return method;
});
exports.default = exports.NativeMethods;
//# sourceMappingURL=Methods.js.map