"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.KSP_PIPE_NAME = void 0;
var events_1 = require("events");
var fs = require("fs");
var net = require("net");
var os = require("os");
var path = require("path");
var Logger_1 = require("./Logger");
var devices_1 = require("./types/devices");
var error_codes_1 = require("./types/error_codes");
var flows_1 = require("./types/flows");
//README
//https://gitlab.mgmt.infocert.it/cadike/infocertksp/-/blob/develop/README.md?ref_type=heads&plain=0
var userInfo = os.userInfo();
//Server KSP che invia i comandi al wrapper
exports.KSP_PIPE_NAME = 'gosign_keycontroller' + userInfo.username;
var PipeServer = /** @class */ (function (_super) {
    __extends(PipeServer, _super);
    function PipeServer(_a) {
        var getDevices = _a.getDevices, flowStart = _a.flowStart, logger = _a.logger, profile = _a.profile, messageSubject = _a.messageSubject;
        var _this = this;
        var _b;
        _this = _super.call(this) || this;
        _this.server = null;
        _this.client = null;
        _this.pipeName = exports.KSP_PIPE_NAME;
        _this.logger = new Logger_1.Logger();
        _this.dataBuffer = Buffer.alloc(0);
        _this.getDevices = getDevices;
        _this.flowStart = flowStart;
        _this.logger = logger;
        _this.messageSubject = messageSubject;
        _this.profile = profile;
        //se passo pipename custom
        _this.pipeName = ((_b = _this.profile) === null || _b === void 0 ? void 0 : _b.pipeName) ? _this.profile.pipeName + userInfo.username : exports.KSP_PIPE_NAME;
        if (os.platform() === 'win32') {
            _this.pipePath = path.join('\\\\.\\pipe\\', _this.pipeName);
        }
        else {
            // Assicurati che il named pipe non esista già
            try {
                if (fs.existsSync(_this.pipePath)) {
                    fs.unlinkSync(_this.pipePath);
                }
            }
            catch (err) {
                console.error('Errore nella pulizia del named pipe:', err);
                process.exit(1);
            }
            _this.pipePath = path.join('/tmp/', _this.pipeName);
        }
        _this.logger.log('PipeServer ' + _this.pipePath);
        return _this;
    }
    Object.defineProperty(PipeServer.prototype, "pipeFlow", {
        get: function () {
            return this._pipeFlow;
        },
        enumerable: false,
        configurable: true
    });
    PipeServer.prototype.start = function () {
        var _this = this;
        //this.logger.log('PipeServer start');
        console.log('PipeServer start with name ' + this.pipeName);
        this.messageSubject.next({
            msg_type: "pipesignevent",
            payload: { label: "PipeServer start" },
            timestamp: new Date().getTime()
        });
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.server) {
                            console.log('Server già in esecuzione');
                            return [2 /*return*/, resolve(true)];
                        }
                        return [4 /*yield*/, this.stop()];
                    case 1:
                        _a.sent();
                        this.server = net.createServer(function (socket) {
                            console.log('Client connesso', socket.address());
                            socket.on('data', function (data) {
                                //gestisco i dati ricevuti
                                _this.onData(data, socket);
                            });
                            socket.on('end', function () {
                                console.log('Client disconnesso');
                            });
                        });
                        this.server.listen(this.pipePath, function () {
                            console.log("Server in ascolto su ".concat(_this.pipePath));
                            resolve(true);
                        });
                        console.log('Server avviato');
                        console.log("🚀 ~ PipeServer ~ constructor ~ pipePath:", {
                            os: os.platform(),
                            pipeName: this.pipeName,
                            pipePath: this.pipePath,
                        });
                        return [2 /*return*/, resolve(true)];
                }
            });
        }); });
    };
    PipeServer.prototype.stop = function () {
        var _this = this;
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    // if (!this.server) {
                    //   console.log('Server non in esecuzione');
                    //   return;
                    // }
                    if (this.server) {
                        this.server.close(function () {
                            console.log('Server fermato');
                        });
                    }
                    this.server = null;
                    if (os.platform() !== 'win32') {
                        try {
                            fs.unlinkSync(this.pipePath);
                            console.log('Named pipe rimosso');
                        }
                        catch (err) {
                            console.warn('Errore nella rimozione del named pipe:', err === null || err === void 0 ? void 0 : err.message);
                        }
                    }
                }
                catch (err) {
                    console.warn('Errore nella chiusura del server:', err === null || err === void 0 ? void 0 : err.message);
                    return [2 /*return*/, resolve(false)];
                }
                resolve(true);
                return [2 /*return*/];
            });
        }); });
    };
    PipeServer.prototype.onData = function (data, socket) {
        return __awaiter(this, void 0, void 0, function () {
            var messageLength, message, jsonResponse;
            return __generator(this, function (_a) {
                console.log('Dati ricevuti:', data.toString());
                this.dataBuffer = Buffer.concat([this.dataBuffer, data]);
                while (this.dataBuffer.length > 4) {
                    messageLength = this.dataBuffer.readInt32LE(0);
                    console.log("🚀 ~ PipeServer ~ onData ~ messageLength:", messageLength);
                    if (this.dataBuffer.length >= 4 + messageLength) {
                        message = this.dataBuffer.toString('utf8', 4, 4 + messageLength);
                        console.log('Richiesta dal client:', message);
                        try {
                            jsonResponse = JSON.parse(message);
                            console.log('Richiesta dal client (JSON):', jsonResponse);
                            this.manageResponse(jsonResponse, socket);
                        }
                        catch (e) {
                            console.error('Errore nel parsing JSON:', e);
                        }
                        this.dataBuffer = this.dataBuffer.slice(4 + messageLength);
                    }
                    else {
                        console.log('Buffer non completo');
                        break;
                    }
                }
                return [2 /*return*/];
            });
        });
    };
    PipeServer.prototype.manageResponse = function (dataJson, socket) {
        return __awaiter(this, void 0, void 0, function () {
            var responseData, _a, devices, formattedCertificates, keyId, sessionId, hash, signParams;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        responseData = undefined;
                        _a = dataJson.command;
                        switch (_a) {
                            case 'readKeys': return [3 /*break*/, 1];
                            case 'signHash': return [3 /*break*/, 3];
                            case 'flushSession': return [3 /*break*/, 5];
                        }
                        return [3 /*break*/, 6];
                    case 1:
                        console.log("readKeys");
                        return [4 /*yield*/, this.getDevices()];
                    case 2:
                        devices = _b.sent();
                        formattedCertificates = this.formatPipeCertificate(devices);
                        console.log("🚀 ~ PipeServer ~ onData ~ formattedCertificates:", formattedCertificates);
                        responseData = formattedCertificates;
                        this.sendResponse(responseData, socket);
                        return [3 /*break*/, 7];
                    case 3:
                        keyId = dataJson.keyId, sessionId = dataJson.sessionId, hash = dataJson.hash;
                        console.log("signHash", { keyId: keyId, sessionId: sessionId, hash: hash });
                        signParams = {
                            hashes: [hash],
                            keyId: keyId
                        };
                        return [4 /*yield*/, this.createPipeSignFlow(signParams)];
                    case 4:
                        _b.sent();
                        this._pipeFlow.FlowData$.subscribe({
                            next: function (data) { return __awaiter(_this, void 0, void 0, function () {
                                var responseData_1, op_result, result, results, signHashResponse;
                                return __generator(this, function (_a) {
                                    console.log('PipeServer flow.FlowData$', data);
                                    //FINAL STATE
                                    if (data.is_final || data.state_type === flows_1.FlowStateType.DGS_STATE_PIPE_SIGN_DONE) {
                                        console.log("FINAL STATE");
                                        responseData_1 = data.state_data;
                                        op_result = responseData_1.op_result, result = responseData_1.result, results = responseData_1.results;
                                        signHashResponse = {};
                                        if (op_result == flows_1.FlowOperationResult.DGS_OP_KO) {
                                            //Errore generico
                                            signHashResponse["success"] = false;
                                            signHashResponse["errcode"] = result;
                                            signHashResponse["errmsg"] = "Signature error: " + result;
                                        }
                                        else if (results[0].result != error_codes_1.ErrorCodes.DGS_OK) {
                                            //Errore di firma
                                            signHashResponse["success"] = false;
                                            signHashResponse["errcode"] = results[0].result;
                                            signHashResponse["errmsg"] = "Signature error: " + results[0].result;
                                        }
                                        else {
                                            //Successo
                                            signHashResponse["success"] = true;
                                            signHashResponse["signedHash"] = results[0].signedHash;
                                        }
                                        return [2 /*return*/, this.sendResponse(signHashResponse, socket)];
                                    }
                                    return [2 /*return*/];
                                });
                            }); },
                            error: function (err) {
                                console.error("Pipe Flow error", err);
                            },
                            complete: function () {
                                console.log("pipe Flow completed!");
                            },
                        });
                        return [3 /*break*/, 7];
                    case 5:
                        // eseguire il comando e prendere il risultato
                        /*
                        {
                            command : "flushSession",
                            sessionId : <sessionId>
                        }
                        */
                        console.log("flushSession");
                        responseData = "flushSession";
                        this.sendResponse(responseData, socket);
                        return [3 /*break*/, 7];
                    case 6:
                        console.log("comando non riconosciuto");
                        responseData = "comando non riconosciuto";
                        this.sendResponse(responseData, socket);
                        return [3 /*break*/, 7];
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    PipeServer.prototype.connect = function (targetPipeName) {
        var _this = this;
        if (targetPipeName === void 0) { targetPipeName = exports.KSP_PIPE_NAME; }
        return new Promise(function (resolve, reject) {
            var targetPipePath;
            if (os.platform() === 'win32') {
                targetPipePath = path.join('\\\\.\\pipe\\', targetPipeName);
            }
            else {
                targetPipePath = path.join('/tmp/', targetPipeName);
            }
            if (!_this.client) {
                _this.client = new net.Socket();
                _this.client.connect(targetPipePath, function () {
                    var _a;
                    console.log("Connesso al server ".concat(targetPipeName));
                    (_a = _this.client) === null || _a === void 0 ? void 0 : _a.on('data', function (data) {
                        console.log('Dati ricevuti:', data.toString());
                        //this.emit('data', data);
                    });
                    if (!_this.client) {
                        reject('Client non inizializzato');
                        return;
                    }
                    resolve(_this.client);
                });
                _this.client.on('error', function (err) {
                    console.error('Errore di connessione:', err);
                    reject(err);
                });
            }
            else {
                resolve(_this.client);
            }
        });
    };
    PipeServer.prototype.createPipeSignFlow = function (signParams) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.logger.log("PipeServer -> createPipeSignFlow -> params", signParams);
                        if (!this._pipeFlow) return [3 /*break*/, 2];
                        this.logger.log("_pipeFlow exist..aborting..");
                        return [4 /*yield*/, this._pipeFlow.abort()];
                    case 1:
                        _b.sent();
                        this.logger.log("_pipeFlow  aborted");
                        _b.label = 2;
                    case 2:
                        _a = this;
                        return [4 /*yield*/, this.flowStart(flows_1.FlowType.DGS_FLOW_PIPESIGN)];
                    case 3:
                        _a._pipeFlow = _b.sent();
                        this._pipeFlow.send(flows_1.FlowEvent.DGS_EVT_PIPE_SIGNATURE_PARAMS_INSERTED, signParams);
                        return [2 /*return*/];
                }
            });
        });
    };
    PipeServer.prototype.sendTo = function (message, targetPipeName) {
        var _this = this;
        if (targetPipeName === void 0) { targetPipeName = exports.KSP_PIPE_NAME; }
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                (_a = this.client) === null || _a === void 0 ? void 0 : _a.write(message);
                resolve();
                return [2 /*return*/];
            });
        }); });
    };
    PipeServer.prototype.sendResponse = function (responseData, socket) {
        //trasformo in stringa
        var stringResponse = JSON.stringify(responseData);
        console.log('Risposta del server:', stringResponse);
        var responseLength = Buffer.byteLength(stringResponse);
        var response = Buffer.alloc(4 + responseLength);
        response.writeInt32LE(responseLength, 0);
        response.write(stringResponse, 4);
        console.log('Invio la risposta al client...');
        socket.write(response, function (err) {
            if (err) {
                console.log('Error', err);
            }
            else {
                console.log('Response successfully sent!');
            }
        });
        /*const stringResponse = JSON.stringify(responseData);
    
        const response = new Buffer(`${stringResponse.length}${stringResponse}`);
    
        const bytes = response.writeUInt32BE(stringResponse.length, 0);
    
        response.write(stringResponse, bytes, "utf-8");
    
    
        //1) scrivo direttamente sulla socket
        socket.write(response);
        //2) emetto l'evento per il client
        //this.emit('data', response, socket);
        */
    };
    Object.defineProperty(PipeServer.prototype, "enabled", {
        get: function () {
            var _a;
            return !!((_a = this === null || this === void 0 ? void 0 : this.server) === null || _a === void 0 ? void 0 : _a.listening);
        },
        enumerable: false,
        configurable: true
    });
    PipeServer.prototype.formatPipeCertificate = function (devices) {
        var formattedCertificates = [];
        devices.readers.forEach(function (reader) {
            var certificates = reader.certificates;
            certificates.map(function (certificate) {
                var name = certificate.keyId, _a = certificate.x509, keyAlg = _a.keyAlg, keyBitLength = _a.keyLen, keyType = _a.keyType;
                var algGroup = "RSA";
                switch (keyType) {
                    case devices_1.DGS_CERT_KEY_TYPE.KEY_CKK_ECDSA:
                        algGroup = "ECDSA";
                        break;
                    case devices_1.DGS_CERT_KEY_TYPE.KEY_CKK_RSA:
                    default:
                        algGroup = "RSA";
                        break;
                }
                var algId = "RSA";
                switch (keyAlg) {
                    case "rsaEncryption":
                        algId = "RSA";
                        break;
                    default:
                        algId = "ECDSA";
                        break;
                }
                var pipeCertificate = {
                    algGroup: algGroup,
                    algId: algId,
                    keyBitLength: keyBitLength,
                    name: name
                };
                console.log("🚀 ~ PipeServer ~ formattedCertificates ~ pipeCertificate:", pipeCertificate);
                formattedCertificates.push(pipeCertificate);
            });
        });
        /* const devices = [
       { "algGroup": "RSA", "algId": "RSA", "keyBitLength": 2048, "name": "2537d47c6cb46e14" },
       { "algGroup": "RSA", "algId": "RSA", "keyBitLength": 2048, "name": "4ef2ab9fdf68e597" },
       { "algGroup": "RSA", "algId": "RSA", "keyBitLength": 2048, "name": "6041bb1c58819b85" },
       { "algGroup": "RSA", "algId": "RSA", "keyBitLength": 2048, "name": "630d9e47cd9789b1" },
       { "algGroup": "RSA", "algId": "RSA", "keyBitLength": 2048, "name": "6d041de05369b57f" },
       { "algGroup": "RSA", "algId": "RSA", "keyBitLength": 2048, "name": "bfe939e36ba5e4b9" },
       { "algGroup": "RSA", "algId": "RSA", "keyBitLength": 2048, "name": "d611d4d503ff6cf2" }
     ];*/
        return formattedCertificates;
    };
    return PipeServer;
}(events_1.EventEmitter));
exports.default = PipeServer;
//# sourceMappingURL=PipeServerr.js.map