"use strict";
/**
 * @ignore
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatMessage = void 0;
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var schedule = require('node-schedule');
//http://reactivex.io/rxjs/manual/tutorial.html
/**
 * @ignore
 */
/**
 * @ignore
 */
var Scheduler = /** @class */ (function () {
    function Scheduler(getMessages) {
        var _this = this;
        this.getMessages = getMessages;
        this.MessagesSubject = new rxjs_1.Subject();
        this.Messages$ = this.MessagesSubject.asObservable();
        this.FilteredMessages$ = function (msg_type, operationId) {
            if (msg_type === void 0) { msg_type = "signprogress"; }
            if (operationId === void 0) { operationId = ""; }
            return _this.Messages$.pipe((0, operators_1.filter)(function (mess) {
                var _a;
                var isType = mess.msg_type === msg_type;
                var isOperation = true;
                if (msg_type === "signprogress" && operationId) {
                    isOperation = ((_a = mess === null || mess === void 0 ? void 0 : mess.payload) === null || _a === void 0 ? void 0 : _a.operationId) == operationId;
                }
                return isType && isOperation;
            }));
        };
        this.start();
    }
    Scheduler.prototype.start = function () {
        //console.log("Started Scheduler")
        //this.startCrons();
        this.getNewMessages();
    };
    Scheduler.prototype.stop = function () {
    };
    Scheduler.prototype.startCrons = function () {
        var every10Seconds = schedule.scheduleJob('*/10 * * * * *', function (fireDate) {
            //console.log('send every10Seconds event', fireDate);
            var json = { type: 'foo', data: { fireDate: fireDate } };
            // myObservable.next({ type: 'foo', data: { fireDate } });
            //this.CORE.sendMessages(`${index++}`, "category", json);
        });
    };
    Scheduler.prototype.sendMessages = function (message) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                //console.log("Scheduler -> sendMessages -> message", message)
                this.MessagesSubject.next(message);
                if (message.msg_type !== "quitevent") {
                    setTimeout(function () {
                        _this.getNewMessages();
                    }, 0);
                }
                else {
                    console.log("Last message close");
                    this.MessagesSubject.complete();
                    this.MessagesSubject.unsubscribe();
                }
                return [2 /*return*/];
            });
        });
    };
    Scheduler.prototype.getNewMessages = function () {
        return __awaiter(this, void 0, void 0, function () {
            var newMessage;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log("Scheduler -> getMessages ");
                        return [4 /*yield*/, this.getMessages()];
                    case 1:
                        newMessage = _a.sent();
                        //console.log("newMessage", newMessage)
                        this.sendMessages(newMessage);
                        return [2 /*return*/];
                }
            });
        });
    };
    return Scheduler;
}());
var formatMessage = function (message) {
    var formattedMesage = {
        payload: message.payload,
        timestamp: message.timestamp
    };
    return formattedMesage;
};
exports.formatMessage = formatMessage;
exports.default = Scheduler;
//# sourceMappingURL=Scheduler.js.map