"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AtrWarning = exports.AnnotPosition = exports.EncryptionAlgorithm = exports.EncryptionMethod = exports.SignAuthenticator = exports.SignPackagingFormat = exports.TimestampFormat = exports.SignFormat = exports.FlowOperationResult = exports.FlowStateType = exports.FlowType = exports.FlowEvent = void 0;
var FlowEvent;
(function (FlowEvent) {
    FlowEvent[FlowEvent["DGS_EVT_CREDENTIAL_INSERTED"] = 0] = "DGS_EVT_CREDENTIAL_INSERTED";
    FlowEvent[FlowEvent["DGS_EVT_OTP_INSERTED"] = 1] = "DGS_EVT_OTP_INSERTED";
    FlowEvent[FlowEvent["DGS_EVT_SIGNATURE_PARAMS_INSERTED"] = 2] = "DGS_EVT_SIGNATURE_PARAMS_INSERTED";
    FlowEvent[FlowEvent["DGS_EVT_RESEND_OTP"] = 3] = "DGS_EVT_RESEND_OTP";
    FlowEvent[FlowEvent["DGS_EVT_POLL_AUTHORIZATION"] = 4] = "DGS_EVT_POLL_AUTHORIZATION";
    FlowEvent[FlowEvent["DGS_EVT_START_SIGN"] = 5] = "DGS_EVT_START_SIGN";
    FlowEvent[FlowEvent["DGS_EVT_VERIFY_PARAMS_INSERTED"] = 6] = "DGS_EVT_VERIFY_PARAMS_INSERTED";
    FlowEvent[FlowEvent["DGS_EVT_WAKEUP"] = 7] = "DGS_EVT_WAKEUP";
    FlowEvent[FlowEvent["DGS_EVT_CERT_PARAMS_INSERTED"] = 8] = "DGS_EVT_CERT_PARAMS_INSERTED";
    FlowEvent[FlowEvent["DGS_EVT_SIGNHASH"] = 9] = "DGS_EVT_SIGNHASH";
    FlowEvent[FlowEvent["DGS_EVT_AUTH_PARAMS_INSERTED"] = 10] = "DGS_EVT_AUTH_PARAMS_INSERTED";
    FlowEvent[FlowEvent["DGS_EVT_SIGNEDHASH"] = 11] = "DGS_EVT_SIGNEDHASH";
    FlowEvent[FlowEvent["DGS_EVT_VERIFY_ADD_COUNTRY_TSL"] = 12] = "DGS_EVT_VERIFY_ADD_COUNTRY_TSL";
    FlowEvent[FlowEvent["DGS_EVT_VERIFY_DETACHED_SOURCES"] = 13] = "DGS_EVT_VERIFY_DETACHED_SOURCES";
    FlowEvent[FlowEvent["DGS_EVT_TIMESTAMP_PARAMS_INSERTED"] = 14] = "DGS_EVT_TIMESTAMP_PARAMS_INSERTED";
    FlowEvent[FlowEvent["DGS_EVT_UPDATE_CHECK_REQUESTED"] = 15] = "DGS_EVT_UPDATE_CHECK_REQUESTED";
    FlowEvent[FlowEvent["DGS_EVT_UPDATE_DOWNLOAD_REQUESTED"] = 16] = "DGS_EVT_UPDATE_DOWNLOAD_REQUESTED";
    FlowEvent[FlowEvent["DGS_EVT_ENCRYPT_PARAMS_INSERTED"] = 17] = "DGS_EVT_ENCRYPT_PARAMS_INSERTED";
    FlowEvent[FlowEvent["DGS_EVT_DECRYPT_PARAMS_INSERTED"] = 18] = "DGS_EVT_DECRYPT_PARAMS_INSERTED";
    FlowEvent[FlowEvent["DGS_EVT_RENEW_WAKEUP"] = 19] = "DGS_EVT_RENEW_WAKEUP";
    FlowEvent[FlowEvent["DGS_EVT_RENEW_SYSSNAPSHOT"] = 20] = "DGS_EVT_RENEW_SYSSNAPSHOT";
    FlowEvent[FlowEvent["DGS_EVT_RENEW_GENP10"] = 21] = "DGS_EVT_RENEW_GENP10";
    FlowEvent[FlowEvent["DGS_EVT_RENEW_PIN_INSERTED"] = 22] = "DGS_EVT_RENEW_PIN_INSERTED";
    FlowEvent[FlowEvent["DGS_EVT_RENEW_CERTINSTALL"] = 23] = "DGS_EVT_RENEW_CERTINSTALL";
    FlowEvent[FlowEvent["DGS_EVT_CONTACT_UPDATE"] = 24] = "DGS_EVT_CONTACT_UPDATE";
    FlowEvent[FlowEvent["DGS_EVT_HASH_RECEIVED"] = 25] = "DGS_EVT_HASH_RECEIVED";
    FlowEvent[FlowEvent["DGS_EVT_WEBSIGN_CONFIRM"] = 26] = "DGS_EVT_WEBSIGN_CONFIRM";
    FlowEvent[FlowEvent["DGS_EVT_EMISSION_GENP10"] = 27] = "DGS_EVT_EMISSION_GENP10";
    FlowEvent[FlowEvent["DGS_EVT_EMISSION_SCPIN_INSERTED"] = 28] = "DGS_EVT_EMISSION_SCPIN_INSERTED";
    FlowEvent[FlowEvent["DGS_EVT_EMISSION_TRASH_CERTS"] = 29] = "DGS_EVT_EMISSION_TRASH_CERTS";
    FlowEvent[FlowEvent["DGS_EVT_EMISSION_RAOPIN_INSERTED"] = 30] = "DGS_EVT_EMISSION_RAOPIN_INSERTED";
    FlowEvent[FlowEvent["DGS_EVT_EMISSION_CERTINSTALL"] = 31] = "DGS_EVT_EMISSION_CERTINSTALL";
    FlowEvent[FlowEvent["DGS_EVT_EMISSION_NCAR"] = 32] = "DGS_EVT_EMISSION_NCAR";
    FlowEvent[FlowEvent["DGS_EVT_EMISSION_SIGNED_P10"] = 33] = "DGS_EVT_EMISSION_SIGNED_P10";
    FlowEvent[FlowEvent["DGS_EVT_PIPE_SIGNATURE_PARAMS_INSERTED"] = 34] = "DGS_EVT_PIPE_SIGNATURE_PARAMS_INSERTED";
    FlowEvent[FlowEvent["DGS_EVT_PIPE_AUTH_PARAMS_INSERTED"] = 35] = "DGS_EVT_PIPE_AUTH_PARAMS_INSERTED";
    FlowEvent[FlowEvent["DGS_EVT_PIPE_SIGN_DONE"] = 36] = "DGS_EVT_PIPE_SIGN_DONE";
    FlowEvent[FlowEvent["DGS_EVT_JWT_INSERTED"] = 37] = "DGS_EVT_JWT_INSERTED";
})(FlowEvent = exports.FlowEvent || (exports.FlowEvent = {}));
var FlowType;
(function (FlowType) {
    /** Flow of type RS BIND */
    FlowType[FlowType["DGS_FLOW_RS_BIND"] = 0] = "DGS_FLOW_RS_BIND";
    /** Flow of type Sign */
    FlowType[FlowType["DGS_FLOW_SIGN"] = 1] = "DGS_FLOW_SIGN";
    /** Flow of type TimeStamp BIND */
    FlowType[FlowType["DGS_FLOW_TS_BIND"] = 2] = "DGS_FLOW_TS_BIND";
    /** Verify flow */
    FlowType[FlowType["DGS_FLOW_VERIFY"] = 3] = "DGS_FLOW_VERIFY";
    /** Flow of type WebSign */
    FlowType[FlowType["DGS_FLOW_WEBSIGN"] = 4] = "DGS_FLOW_WEBSIGN";
    /** Flow of type timestamp */
    FlowType[FlowType["DGS_FLOW_TIMESTAMP"] = 5] = "DGS_FLOW_TIMESTAMP";
    /** Flow of type Update Check */
    FlowType[FlowType["DGS_FLOW_UPDATECHECK"] = 6] = "DGS_FLOW_UPDATECHECK";
    /** Flow of type Encrypt */
    FlowType[FlowType["DGS_FLOW_ENCRYPT"] = 7] = "DGS_FLOW_ENCRYPT";
    /** Flow of type Decrypt */
    FlowType[FlowType["DGS_FLOW_DECRYPT"] = 8] = "DGS_FLOW_DECRYPT";
    /** Renew flow */
    FlowType[FlowType["DGS_FLOW_RENEW"] = 9] = "DGS_FLOW_RENEW";
    /** Emission flow */
    FlowType[FlowType["DGS_FLOW_EMISSION"] = 10] = "DGS_FLOW_EMISSION";
    /** Pipe signature flow */
    FlowType[FlowType["DGS_FLOW_PIPESIGN"] = 11] = "DGS_FLOW_PIPESIGN";
})(FlowType = exports.FlowType || (exports.FlowType = {}));
var FlowStateType;
(function (FlowStateType) {
    FlowStateType[FlowStateType["DGS_STATE_ABORTED"] = -1] = "DGS_STATE_ABORTED";
    /** Wait for remote sign or timestamp credentials (intial state of remote sign/timestamping flows) */
    FlowStateType[FlowStateType["DGS_STATE_BIND_WAIT_CREDENTIALS"] = 0] = "DGS_STATE_BIND_WAIT_CREDENTIALS";
    /** Wait for remote sign bind OTP */
    FlowStateType[FlowStateType["DGS_STATE_BIND_WAIT_OTP"] = 1] = "DGS_STATE_BIND_WAIT_OTP";
    /** Remote sign bind done */
    FlowStateType[FlowStateType["DGS_STATE_BIND_DONE"] = 2] = "DGS_STATE_BIND_DONE";
    /** Wait for signature flow parameters (initial state of sign flow) */
    FlowStateType[FlowStateType["DGS_STATE_SIGN_WAIT_SIGN_PARAMS"] = 3] = "DGS_STATE_SIGN_WAIT_SIGN_PARAMS";
    /**  Final state of sign flow (both for success and error cases) */
    FlowStateType[FlowStateType["DGS_STATE_SIGN_DONE"] = 4] = "DGS_STATE_SIGN_DONE";
    /**  Final state of timestamp bind flow*/
    FlowStateType[FlowStateType["DGS_STATE_TSBIND_DONE"] = 5] = "DGS_STATE_TSBIND_DONE";
    /** Wait for remote signature operation OTP */
    FlowStateType[FlowStateType["DGS_STATE_SIGN_WAIT_OTP"] = 6] = "DGS_STATE_SIGN_WAIT_OTP";
    /** Wait for remote signature opeartion authorization */
    FlowStateType[FlowStateType["DGS_STATE_SIGN_WAIT_AUTHORIZATION"] = 7] = "DGS_STATE_SIGN_WAIT_AUTHORIZATION";
    /** Signature operation is ready to process the current block of files */
    FlowStateType[FlowStateType["DGS_STATE_READY_TO_SIGN"] = 8] = "DGS_STATE_READY_TO_SIGN";
    /** Verify for verify flow parameters (initial state of verify flow) */
    FlowStateType[FlowStateType["DGS_STATE_VERIFY_WAIT_PARAMS"] = 9] = "DGS_STATE_VERIFY_WAIT_PARAMS";
    /** Final state of verify flow (both for success and error cases) */
    FlowStateType[FlowStateType["DGS_STATE_VERIFY_DONE"] = 10] = "DGS_STATE_VERIFY_DONE";
    FlowStateType[FlowStateType["DGS_STATE_WEB_WAIT_WAKEUP"] = 11] = "DGS_STATE_WEB_WAIT_WAKEUP";
    FlowStateType[FlowStateType["DGS_STATE_WEB_WAIT_CERT_PARAMS"] = 12] = "DGS_STATE_WEB_WAIT_CERT_PARAMS";
    FlowStateType[FlowStateType["DGS_STATE_WEB_WAIT_SIGNHASH"] = 13] = "DGS_STATE_WEB_WAIT_SIGNHASH";
    FlowStateType[FlowStateType["DGS_STATE_WEB_WAIT_AUTH_PARAMS"] = 14] = "DGS_STATE_WEB_WAIT_AUTH_PARAMS";
    FlowStateType[FlowStateType["DGS_STATE_WEB_SIGNING"] = 15] = "DGS_STATE_WEB_SIGNING";
    FlowStateType[FlowStateType["DGS_STATE_WEB_SIGN_DONE"] = 16] = "DGS_STATE_WEB_SIGN_DONE";
    /** Wait for countries TSL to add for verify operation */
    FlowStateType[FlowStateType["DGS_STATE_VERIFY_WAIT_TSL"] = 17] = "DGS_STATE_VERIFY_WAIT_TSL";
    /** Wait for detached data file for (for verify operation) */
    FlowStateType[FlowStateType["DGS_STATE_VERIFY_WAIT_DETACHED_SRC"] = 18] = "DGS_STATE_VERIFY_WAIT_DETACHED_SRC";
    /** Wait for timestamp operation parameters */
    FlowStateType[FlowStateType["DGS_STATE_TS_WAIT_PARAMS"] = 19] = "DGS_STATE_TS_WAIT_PARAMS";
    /** Timestamp operation done */
    FlowStateType[FlowStateType["DGS_STATE_TS_DONE"] = 20] = "DGS_STATE_TS_DONE";
    /** Wait update check request */
    FlowStateType[FlowStateType["DGS_STATE_UPDATECHECK_WAIT_REQUEST"] = 21] = "DGS_STATE_UPDATECHECK_WAIT_REQUEST";
    /** Wait user download consent */
    FlowStateType[FlowStateType["DGS_STATE_UPDATECHECK_WAIT_START"] = 22] = "DGS_STATE_UPDATECHECK_WAIT_START";
    /** Update check final state */
    FlowStateType[FlowStateType["DGS_STATE_UPDATECHECK_DONE"] = 23] = "DGS_STATE_UPDATECHECK_DONE";
    /** Encryption initial state */
    FlowStateType[FlowStateType["DGS_STATE_ENCRYPT_WAIT_PARAMS"] = 24] = "DGS_STATE_ENCRYPT_WAIT_PARAMS";
    /** Encryption final state */
    FlowStateType[FlowStateType["DGS_STATE_ENCRYPT_DONE"] = 25] = "DGS_STATE_ENCRYPT_DONE";
    /** Decryption initial state */
    FlowStateType[FlowStateType["DGS_STATE_DECRYPT_WAIT_PARAMS"] = 26] = "DGS_STATE_DECRYPT_WAIT_PARAMS";
    /** Decryption final state */
    FlowStateType[FlowStateType["DGS_STATE_DECRYPT_DONE"] = 27] = "DGS_STATE_DECRYPT_DONE";
    /** Renew accept-all message state */
    FlowStateType[FlowStateType["DGS_STATE_RENEW_WAIT_CMD"] = 28] = "DGS_STATE_RENEW_WAIT_CMD";
    /** Renew wait for PIN state */
    FlowStateType[FlowStateType["DGS_STATE_RENEW_WAIT_PIN"] = 29] = "DGS_STATE_RENEW_WAIT_PIN";
    /** Certificate contact update required */
    FlowStateType[FlowStateType["DGS_STATE_WAIT_CONTACT_INFO"] = 30] = "DGS_STATE_WAIT_CONTACT_INFO";
    /** Wait new hash during sign */
    FlowStateType[FlowStateType["DGS_STATE_SIGN_WAIT_HASH"] = 31] = "DGS_STATE_SIGN_WAIT_HASH";
    /** Confirm during websign */
    FlowStateType[FlowStateType["DGS_STATE_WEB_WAIT_CONFIRM"] = 32] = "DGS_STATE_WEB_WAIT_CONFIRM";
    /** Emission accept-all message state */
    FlowStateType[FlowStateType["DGS_STATE_EMISSION_WAIT_CMD"] = 33] = "DGS_STATE_EMISSION_WAIT_CMD";
    /** Emission wait for Smartcard PIN state */
    FlowStateType[FlowStateType["DGS_STATE_EMISSION_WAIT_SCPIN"] = 34] = "DGS_STATE_EMISSION_WAIT_SCPIN";
    /** Emission wait for Smartcard certs to trash */
    FlowStateType[FlowStateType["DGS_STATE_EMISSION_WAIT_TRASHCERTS"] = 35] = "DGS_STATE_EMISSION_WAIT_TRASHCERTS";
    /** Emission wait for RAO PIN state */
    FlowStateType[FlowStateType["DGS_STATE_EMISSION_WAIT_RAOPIN"] = 36] = "DGS_STATE_EMISSION_WAIT_RAOPIN";
    /** Emission wait for P10 signing */
    FlowStateType[FlowStateType["DGS_STATE_EMISSION_WAIT_P10_SIGNING"] = 37] = "DGS_STATE_EMISSION_WAIT_P10_SIGNING";
    /** Pipe signature wait for hash and certificate */
    FlowStateType[FlowStateType["DGS_STATE_PIPE_WAIT_SIGN_PARAMS"] = 38] = "DGS_STATE_PIPE_WAIT_SIGN_PARAMS";
    /** Pipe signature wait for pin and authenticator */
    FlowStateType[FlowStateType["DGS_STATE_PIPE_WAIT_AUTH_PARAMS"] = 39] = "DGS_STATE_PIPE_WAIT_AUTH_PARAMS";
    /** Pipe signature wait for hash signing */
    FlowStateType[FlowStateType["DGS_STATE_PIPE_WAIT_SIGNING"] = 40] = "DGS_STATE_PIPE_WAIT_SIGNING";
    /** Pipe signature done*/
    FlowStateType[FlowStateType["DGS_STATE_PIPE_SIGN_DONE"] = 41] = "DGS_STATE_PIPE_SIGN_DONE";
    /** Wait for e-seal remote sign bind JWT */
    FlowStateType[FlowStateType["DGS_STATE_BIND_WAIT_JWT"] = 42] = "DGS_STATE_BIND_WAIT_JWT";
})(FlowStateType = exports.FlowStateType || (exports.FlowStateType = {}));
var FlowOperationResult;
(function (FlowOperationResult) {
    FlowOperationResult[FlowOperationResult["DGS_OP_ALL_OK"] = 0] = "DGS_OP_ALL_OK";
    FlowOperationResult[FlowOperationResult["DGS_OP_PARTIAL_OK"] = 1] = "DGS_OP_PARTIAL_OK";
    FlowOperationResult[FlowOperationResult["DGS_OP_KO"] = 2] = "DGS_OP_KO";
    FlowOperationResult[FlowOperationResult["DGS_OP_ABORTED"] = 3] = "DGS_OP_ABORTED";
})(FlowOperationResult = exports.FlowOperationResult || (exports.FlowOperationResult = {}));
/** Signature format */
var SignFormat;
(function (SignFormat) {
    /** CAdES signature */
    SignFormat[SignFormat["DGS_SIGN_TYPE_CADES"] = 0] = "DGS_SIGN_TYPE_CADES";
    /** PAdES signature */
    SignFormat[SignFormat["DGS_SIGN_TYPE_PADES"] = 1] = "DGS_SIGN_TYPE_PADES";
    /** XAdES signature */
    SignFormat[SignFormat["DGS_SIGN_TYPE_XADES"] = 2] = "DGS_SIGN_TYPE_XADES";
})(SignFormat = exports.SignFormat || (exports.SignFormat = {}));
var TimestampFormat;
(function (TimestampFormat) {
    /** TSD timestamp format */
    TimestampFormat[TimestampFormat["DGS_TIMESTAMP_TSD"] = 0] = "DGS_TIMESTAMP_TSD";
    /** M7M timestamp format */
    TimestampFormat[TimestampFormat["DGS_TIMESTAMP_M7M"] = 1] = "DGS_TIMESTAMP_M7M";
    /** TSR detached timestamp format */
    TimestampFormat[TimestampFormat["DGS_TIMESTAMP_TSR"] = 2] = "DGS_TIMESTAMP_TSR";
})(TimestampFormat = exports.TimestampFormat || (exports.TimestampFormat = {}));
;
var SignPackagingFormat;
(function (SignPackagingFormat) {
    /** Enveloped packaging (CAdES, XAdES, PAdES) */
    SignPackagingFormat[SignPackagingFormat["DGS_SIGN_PKG_ENVELOPED"] = 0] = "DGS_SIGN_PKG_ENVELOPED";
    /** CAdES signature (XAdES only) */
    SignPackagingFormat[SignPackagingFormat["DGS_SIGN_PKG_ENVELOPING"] = 1] = "DGS_SIGN_PKG_ENVELOPING";
    /** CAdES signature (CAdES, XAdES) */
    SignPackagingFormat[SignPackagingFormat["DGS_SIGN_PKG_DETACHED"] = 2] = "DGS_SIGN_PKG_DETACHED";
})(SignPackagingFormat = exports.SignPackagingFormat || (exports.SignPackagingFormat = {}));
var SignAuthenticator;
(function (SignAuthenticator) {
    /** SMS code auth */
    SignAuthenticator[SignAuthenticator["DGS_AUTH_SMSP"] = 1] = "DGS_AUTH_SMSP";
    /** OTP code auth */
    SignAuthenticator[SignAuthenticator["DGS_AUTH_OTPS"] = 2] = "DGS_AUTH_OTPS";
    /** QrCode scan auth */
    SignAuthenticator[SignAuthenticator["DGS_AUTH_QRCD"] = 4] = "DGS_AUTH_QRCD";
    /** App push notification auth */
    SignAuthenticator[SignAuthenticator["DGS_AUTH_FIDO"] = 8] = "DGS_AUTH_FIDO";
    /** SignAPI OTP code auth */
    SignAuthenticator[SignAuthenticator["DGS_AUTH_TOTP"] = 16] = "DGS_AUTH_TOTP";
    /** SignAPI App push notification auth */
    SignAuthenticator[SignAuthenticator["DGS_AUTH_PUSH"] = 32] = "DGS_AUTH_PUSH";
})(SignAuthenticator = exports.SignAuthenticator || (exports.SignAuthenticator = {}));
var EncryptionMethod;
(function (EncryptionMethod) {
    /** Encrypt with password */
    EncryptionMethod[EncryptionMethod["DGS_CRYPT_METHOD_STRING"] = 0] = "DGS_CRYPT_METHOD_STRING";
    /** Encrypt with Smart Card Certificate */
    EncryptionMethod[EncryptionMethod["DGS_CRYPT_METHOD_SC"] = 1] = "DGS_CRYPT_METHOD_SC";
    /** Encrypt with Certificate from P12 file */
    EncryptionMethod[EncryptionMethod["DGS_CRYPT_METHOD_P12"] = 2] = "DGS_CRYPT_METHOD_P12";
    /** Encrypt with Certificate from CER file */
    EncryptionMethod[EncryptionMethod["DGS_CRYPT_METHOD_FILE"] = 3] = "DGS_CRYPT_METHOD_FILE";
})(EncryptionMethod = exports.EncryptionMethod || (exports.EncryptionMethod = {}));
;
var EncryptionAlgorithm;
(function (EncryptionAlgorithm) {
    /** Uses "aes-256-cbc" encryption algorithm */
    EncryptionAlgorithm[EncryptionAlgorithm["DGS_CRYPT_ALGORITHM_AESCBC"] = 0] = "DGS_CRYPT_ALGORITHM_AESCBC";
    /** Uses "3-des" encryption algorithm */
    EncryptionAlgorithm[EncryptionAlgorithm["DGS_CRYPT_ALGORITHM_3DES"] = 1] = "DGS_CRYPT_ALGORITHM_3DES";
    /** Uses "blowfish" encryption algorithm */
    EncryptionAlgorithm[EncryptionAlgorithm["DGS_CRYPT_ALGORITHM_BLOWFISH"] = 2] = "DGS_CRYPT_ALGORITHM_BLOWFISH";
    /** Uses "des" encryption algorithm */
    EncryptionAlgorithm[EncryptionAlgorithm["DGS_CRYPT_ALGORITHM_DES"] = 3] = "DGS_CRYPT_ALGORITHM_DES";
    /** Uses "aes-256-gcm" encryption algorithm */
    EncryptionAlgorithm[EncryptionAlgorithm["DGS_CRYPT_ALGORITHM_AESGCM"] = 4] = "DGS_CRYPT_ALGORITHM_AESGCM";
})(EncryptionAlgorithm = exports.EncryptionAlgorithm || (exports.EncryptionAlgorithm = {}));
;
;
;
/*Position on annotation*/
var AnnotPosition;
(function (AnnotPosition) {
    /** old school signature format */
    AnnotPosition[AnnotPosition["DGS_SIGN_PADES_ANNOT_POSITION_AT_LEFT"] = 0] = "DGS_SIGN_PADES_ANNOT_POSITION_AT_LEFT";
    /** new school 2022 signature format */
    AnnotPosition[AnnotPosition["DGS_SIGN_PADES_ANNOT_POSITION_AT_RIGHT_OF_CENTER"] = 1] = "DGS_SIGN_PADES_ANNOT_POSITION_AT_RIGHT_OF_CENTER";
})(AnnotPosition = exports.AnnotPosition || (exports.AnnotPosition = {}));
;
/** Atr Warning */
var AtrWarning;
(function (AtrWarning) {
    AtrWarning[AtrWarning["Others"] = 0] = "Others";
    AtrWarning[AtrWarning["COSMOv7"] = 1] = "COSMOv7";
    AtrWarning[AtrWarning["COSMOv9_1"] = 2] = "COSMOv9_1";
    AtrWarning[AtrWarning["JSign2BIT4ID"] = 3] = "JSign2BIT4ID";
    AtrWarning[AtrWarning["JSign2SAFEDIVE"] = 4] = "JSign2SAFEDIVE";
    AtrWarning[AtrWarning["JSign3"] = 5] = "JSign3";
    AtrWarning[AtrWarning["JSign4"] = 6] = "JSign4";
    AtrWarning[AtrWarning["CNSv2"] = 7] = "CNSv2";
    AtrWarning[AtrWarning["Gemalto"] = 8] = "Gemalto";
    AtrWarning[AtrWarning["TOUCHANDSIGN"] = 9] = "TOUCHANDSIGN";
    AtrWarning[AtrWarning["JSign1"] = 10] = "JSign1";
})(AtrWarning = exports.AtrWarning || (exports.AtrWarning = {}));
//# sourceMappingURL=flows.js.map