"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.COUNTRY_CODE = exports.LogLevel = exports.Envs = void 0;
var ref;
try {
    ref = require('@lwahonen/ref-napi');
}
catch (err) {
    ref = require('ref-napi');
}
//https://github.com/node-ffi/node-ffi/wiki/Node-FFI-Tutorial
/**  @ignore */
var pointer = ref.refType("pointer");
exports.default = {
    void: "void",
    voidFunction: ref.types.void,
    int: ref.types.int,
    uint: ref.types.uint,
    float: ref.types.float,
    string: "string",
    refString: ref.refType("string"),
    char: ref.types.char,
    pointer: pointer,
    pointerOfPointer: ref.refType(pointer),
    pointerInt: ref.refType("int"),
    bool: ref.types.bool,
    DGS_RESULT: ref.types.int,
    uchar: ref.types.uchar
};
/**
 * Environments list
 */
var Envs;
(function (Envs) {
    /**Default production environments */
    Envs[Envs["DGS_ENV_PRODUCTION"] = 0] = "DGS_ENV_PRODUCTION";
    Envs[Envs["DGS_ENV_TEST"] = 1] = "DGS_ENV_TEST";
})(Envs = exports.Envs || (exports.Envs = {}));
/**
 *  License Interface
 */
var LogLevel;
(function (LogLevel) {
    LogLevel[LogLevel["DGS_LVL_CRITICAL"] = 0] = "DGS_LVL_CRITICAL";
    LogLevel[LogLevel["DGS_LVL_ERROR"] = 1] = "DGS_LVL_ERROR";
    LogLevel[LogLevel["DGS_LVL_WARNING"] = 2] = "DGS_LVL_WARNING";
    LogLevel[LogLevel["DGS_LVL_INFO"] = 3] = "DGS_LVL_INFO";
    LogLevel[LogLevel["DGS_LVL_DEBUG"] = 4] = "DGS_LVL_DEBUG";
    LogLevel[LogLevel["DGS_LVL_TRACE"] = 5] = "DGS_LVL_TRACE";
})(LogLevel = exports.LogLevel || (exports.LogLevel = {}));
var COUNTRY_CODE;
(function (COUNTRY_CODE) {
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_AT"] = 0] = "DGS_CC_AT";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_BE"] = 1] = "DGS_CC_BE";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_BG"] = 2] = "DGS_CC_BG";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_CY"] = 3] = "DGS_CC_CY";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_CZ"] = 4] = "DGS_CC_CZ";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_DE"] = 5] = "DGS_CC_DE";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_DK"] = 6] = "DGS_CC_DK";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_EE"] = 7] = "DGS_CC_EE";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_EL"] = 8] = "DGS_CC_EL";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_ES"] = 9] = "DGS_CC_ES";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_FI"] = 10] = "DGS_CC_FI";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_FR"] = 11] = "DGS_CC_FR";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_HR"] = 12] = "DGS_CC_HR";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_HU"] = 13] = "DGS_CC_HU";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_IE"] = 14] = "DGS_CC_IE";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_IS"] = 15] = "DGS_CC_IS";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_IT"] = 16] = "DGS_CC_IT";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_LI"] = 17] = "DGS_CC_LI";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_LT"] = 18] = "DGS_CC_LT";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_LU"] = 19] = "DGS_CC_LU";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_LV"] = 20] = "DGS_CC_LV";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_MT"] = 21] = "DGS_CC_MT";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_NL"] = 22] = "DGS_CC_NL";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_NO"] = 23] = "DGS_CC_NO";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_PL"] = 24] = "DGS_CC_PL";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_PT"] = 25] = "DGS_CC_PT";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_RO"] = 26] = "DGS_CC_RO";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_SE"] = 27] = "DGS_CC_SE";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_SI"] = 28] = "DGS_CC_SI";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_SK"] = 29] = "DGS_CC_SK";
    COUNTRY_CODE[COUNTRY_CODE["DGS_CC_UK"] = 30] = "DGS_CC_UK";
})(COUNTRY_CODE = exports.COUNTRY_CODE || (exports.COUNTRY_CODE = {}));
//# sourceMappingURL=index.js.map