"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VerifyWarningCode = exports.VerificationLevel = void 0;
/** Signature/timestamp resulting verification level */
var VerificationLevel;
(function (VerificationLevel) {
    /** Verification level undefined */
    VerificationLevel[VerificationLevel["DGS_VERIFY_UNDEF"] = 0] = "DGS_VERIFY_UNDEF";
    /** Success verification levels (1-4 the lower the better) */
    VerificationLevel[VerificationLevel["DGS_VERIFY_OK_LVL1"] = 1] = "DGS_VERIFY_OK_LVL1";
    VerificationLevel[VerificationLevel["DGS_VERIFY_OK_LVL2"] = 2] = "DGS_VERIFY_OK_LVL2";
    VerificationLevel[VerificationLevel["DGS_VERIFY_OK_LVL3"] = 3] = "DGS_VERIFY_OK_LVL3";
    VerificationLevel[VerificationLevel["DGS_VERIFY_OK_LVL4"] = 4] = "DGS_VERIFY_OK_LVL4";
    /** Partial success verification */
    VerificationLevel[VerificationLevel["DGS_VERIFY_WARN"] = 254] = "DGS_VERIFY_WARN";
    /** Not verified */
    VerificationLevel[VerificationLevel["DGS_VERIFY_KO"] = 255] = "DGS_VERIFY_KO";
})(VerificationLevel = exports.VerificationLevel || (exports.VerificationLevel = {}));
/** Codes of warning/notices of signature/verification reports */
var VerifyWarningCode;
(function (VerifyWarningCode) {
    VerifyWarningCode[VerifyWarningCode["QSCD_ESEAL"] = 0] = "QSCD_ESEAL";
    VerifyWarningCode[VerifyWarningCode["KEYSAGE_BF"] = 1] = "KEYSAGE_BF";
    VerifyWarningCode[VerifyWarningCode["KEYSAGE_CDE"] = 2] = "KEYSAGE_CDE";
    VerifyWarningCode[VerifyWarningCode["NOT_CADES_COMPLIANT"] = 3] = "NOT_CADES_COMPLIANT";
    VerifyWarningCode[VerifyWarningCode["NOT_PADES_COMPLIANT"] = 4] = "NOT_PADES_COMPLIANT";
    VerifyWarningCode[VerifyWarningCode["PADES_BASIC"] = 5] = "PADES_BASIC";
    VerifyWarningCode[VerifyWarningCode["PDF_SIGNED_SIGNINTIME"] = 6] = "PDF_SIGNED_SIGNINTIME";
    VerifyWarningCode[VerifyWarningCode["OBSOLETE_DIGEST"] = 7] = "OBSOLETE_DIGEST";
    VerifyWarningCode[VerifyWarningCode["KEY_NOT_ON_SECURE_DEVICE"] = 8] = "KEY_NOT_ON_SECURE_DEVICE";
    VerifyWarningCode[VerifyWarningCode["CAROOT_NOT_TRUSTED"] = 9] = "CAROOT_NOT_TRUSTED";
    VerifyWarningCode[VerifyWarningCode["TS_OBSOLETE_DIGEST"] = 10] = "TS_OBSOLETE_DIGEST";
    VerifyWarningCode[VerifyWarningCode["TS_NATIONAL_LEVEL"] = 11] = "TS_NATIONAL_LEVEL";
    VerifyWarningCode[VerifyWarningCode["REVCHECK_FAILED"] = 12] = "REVCHECK_FAILED";
    VerifyWarningCode[VerifyWarningCode["CA_CERT_EXPIRED"] = 13] = "CA_CERT_EXPIRED";
    VerifyWarningCode[VerifyWarningCode["CERT_EXPIRED"] = 14] = "CERT_EXPIRED";
    VerifyWarningCode[VerifyWarningCode["CA_ROOT_FROM_ATL"] = 15] = "CA_ROOT_FROM_ATL";
    VerifyWarningCode[VerifyWarningCode["PDF_MODIFIED_AFTER_SIGN"] = 16] = "PDF_MODIFIED_AFTER_SIGN";
    VerifyWarningCode[VerifyWarningCode["PDF_CORRUPTED_AFTER_SIGN"] = 17] = "PDF_CORRUPTED_AFTER_SIGN";
    VerifyWarningCode[VerifyWarningCode["TS_NOT_CADES_COMPLIANT"] = 18] = "TS_NOT_CADES_COMPLIANT";
    VerifyWarningCode[VerifyWarningCode["TS_NOT_EIDAS_COMPLIANT"] = 19] = "TS_NOT_EIDAS_COMPLIANT";
    VerifyWarningCode[VerifyWarningCode["SIGNED_ATTRS_NOT_ORDERED"] = 20] = "SIGNED_ATTRS_NOT_ORDERED";
})(VerifyWarningCode = exports.VerifyWarningCode || (exports.VerifyWarningCode = {}));
//# sourceMappingURL=verifyreport.js.map