const {
  contextBridge,
  ipcRenderer
} = require('electron');
const path = require('path')
const {
  loadElectronProfile
} = require('./electron/Utils');

const profile = loadElectronProfile(path.join(__dirname, '/current-customization/profile.jwt'));

contextBridge.exposeInMainWorld('dikeCore', {
  send: (channel, data) => {
    ipcRenderer.send(channel, data);
  },
  once: (channel, func) => {
    ipcRenderer.once(channel, (event, response) => func(event, response));
  },
  on: (channel, func) => {
    ipcRenderer.on(channel, (event, response) => func(event, response));
  },
});

var dikeParams = {
  testing: process.argv.includes('--cl'),
  cl: process.argv.includes('--cl'),
  host: process.platform,
  profile: profile,
  skipupdate: process.argv.includes('--skipupdate'),
  tdd: process.argv.includes('--tdd'),
};
console.log('dikeParams', dikeParams);
contextBridge.exposeInMainWorld('dikeParams', dikeParams);
